# Intrinio API
#
# Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
#
# OpenAPI spec version: 2.14.0
# 
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' ETF Class
#'
#' @field id 
#' @field name 
#' @field ticker 
#' @field figi_ticker 
#' @field ric 
#' @field isin 
#' @field sedol 
#' @field exchange_mic 
#' @field sponsor 
#' @field type 
#' @field description 
#' @field inception_date 
#' @field data_change_date 
#' @field close_date 
#' @field is_live_listed 
#' @field legal_structure 
#' @field intraday_nav_ticker 
#' @field primary_ticker 
#' @field primary_ticker_country_code 
#' @field primary_listing_region 
#' @field net_expense_ratio 
#' @field asset_class 
#' @field other_asset_types 
#' @field market_cap_range 
#' @field holds_only_nyse_stocks 
#' @field holds_only_nasdaq_stocks 
#' @field growth_value_tilt 
#' @field growth_type 
#' @field value_type 
#' @field sector 
#' @field industry 
#' @field sub_industry 
#' @field cross_sector_theme 
#' @field natural_resources_type 
#' @field excludes_financials 
#' @field excludes_technology 
#' @field us_or_excludes_us 
#' @field developed_emerging 
#' @field specialized_region 
#' @field continent 
#' @field latin_america_sub_group 
#' @field europe_sub_group 
#' @field asia_sub_group 
#' @field specific_country 
#' @field china_listing_location 
#' @field us_state 
#' @field real_estate 
#' @field index_weighting_scheme 
#' @field market_cap_weighting_type 
#' @field fundamental_weighting_type 
#' @field dividend_weighting_type 
#' @field bond_type 
#' @field government_bond_types 
#' @field municipal_bond_region 
#' @field municipal_vrdo 
#' @field mortgage_bond_types 
#' @field bond_tax_status 
#' @field credit_quality 
#' @field average_maturity 
#' @field specific_maturity_year 
#' @field bond_currency_denomination 
#' @field laddered 
#' @field zero_coupon 
#' @field floating_rate 
#' @field build_america_bonds 
#' @field commodity_types 
#' @field energy_type 
#' @field agricultural_type 
#' @field metal_type 
#' @field inverse_leveraged 
#' @field target_date_multi_asset_type 
#' @field currency_hedged 
#' @field currency_pair 
#' @field social_environmental_type 
#' @field clean_energy_type 
#' @field dividend_type 
#' @field regular_dividend_payor_type 
#' @field holds_ml_ps 
#' @field holds_preferred_stock 
#' @field holds_closed_end_funds 
#' @field quant_strategies_type 
#' @field other_quant_models 
#' @field hedge_fund_type 
#' @field derivatives_based 
#' @field holds_ad_rs 
#' @field index_linked 
#' @field includes_short_exposure 
#' @field index_name 
#' @field parent_index 
#' @field index_family 
#' @field broader_index_family 
#' @field index_provider 
#' @field fund_family 
#' @field index_ticker 
#' @field etn_issuing_bank 
#' @field etn_maturity_date 
#' @field livestock 
#' @field dynamic_futures_roll 
#' @field index_provider_code 
#' @field single_category_designation 
#' @field registered_countries 
#' @field issuing_entity_country_code 
#' @field ucits 
#' @field replication_structure 
#' @field domicile 
#' @field base_currency 
#' @field listing_currency 
#' @field fund_listing_date 
#' @field listing_country_code 
#' @field listing_region 
#' @field smartvs_traditional_beta 
#' @field smartvs_traditional_beta_level2 
#' @field income_category 
#' @field etp_structure_type 
#' @field month_end_assets 
#' @field etf_portfolio_turnover 
#' @field firstbridge_id 
#' @field firstbridge_parent_id 
#' @field number_of_holdings 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
ETF <- R6::R6Class(
  'ETF',
  public = list(
    `id` = NA,
    `name` = NA,
    `ticker` = NA,
    `figi_ticker` = NA,
    `ric` = NA,
    `isin` = NA,
    `sedol` = NA,
    `exchange_mic` = NA,
    `sponsor` = NA,
    `type` = NA,
    `description` = NA,
    `inception_date` = NA,
    `data_change_date` = NA,
    `close_date` = NA,
    `is_live_listed` = NA,
    `legal_structure` = NA,
    `intraday_nav_ticker` = NA,
    `primary_ticker` = NA,
    `primary_ticker_country_code` = NA,
    `primary_listing_region` = NA,
    `net_expense_ratio` = NA,
    `asset_class` = NA,
    `other_asset_types` = NA,
    `market_cap_range` = NA,
    `holds_only_nyse_stocks` = NA,
    `holds_only_nasdaq_stocks` = NA,
    `growth_value_tilt` = NA,
    `growth_type` = NA,
    `value_type` = NA,
    `sector` = NA,
    `industry` = NA,
    `sub_industry` = NA,
    `cross_sector_theme` = NA,
    `natural_resources_type` = NA,
    `excludes_financials` = NA,
    `excludes_technology` = NA,
    `us_or_excludes_us` = NA,
    `developed_emerging` = NA,
    `specialized_region` = NA,
    `continent` = NA,
    `latin_america_sub_group` = NA,
    `europe_sub_group` = NA,
    `asia_sub_group` = NA,
    `specific_country` = NA,
    `china_listing_location` = NA,
    `us_state` = NA,
    `real_estate` = NA,
    `index_weighting_scheme` = NA,
    `market_cap_weighting_type` = NA,
    `fundamental_weighting_type` = NA,
    `dividend_weighting_type` = NA,
    `bond_type` = NA,
    `government_bond_types` = NA,
    `municipal_bond_region` = NA,
    `municipal_vrdo` = NA,
    `mortgage_bond_types` = NA,
    `bond_tax_status` = NA,
    `credit_quality` = NA,
    `average_maturity` = NA,
    `specific_maturity_year` = NA,
    `bond_currency_denomination` = NA,
    `laddered` = NA,
    `zero_coupon` = NA,
    `floating_rate` = NA,
    `build_america_bonds` = NA,
    `commodity_types` = NA,
    `energy_type` = NA,
    `agricultural_type` = NA,
    `metal_type` = NA,
    `inverse_leveraged` = NA,
    `target_date_multi_asset_type` = NA,
    `currency_hedged` = NA,
    `currency_pair` = NA,
    `social_environmental_type` = NA,
    `clean_energy_type` = NA,
    `dividend_type` = NA,
    `regular_dividend_payor_type` = NA,
    `holds_ml_ps` = NA,
    `holds_preferred_stock` = NA,
    `holds_closed_end_funds` = NA,
    `quant_strategies_type` = NA,
    `other_quant_models` = NA,
    `hedge_fund_type` = NA,
    `derivatives_based` = NA,
    `holds_ad_rs` = NA,
    `index_linked` = NA,
    `includes_short_exposure` = NA,
    `index_name` = NA,
    `parent_index` = NA,
    `index_family` = NA,
    `broader_index_family` = NA,
    `index_provider` = NA,
    `fund_family` = NA,
    `index_ticker` = NA,
    `etn_issuing_bank` = NA,
    `etn_maturity_date` = NA,
    `livestock` = NA,
    `dynamic_futures_roll` = NA,
    `index_provider_code` = NA,
    `single_category_designation` = NA,
    `registered_countries` = NA,
    `issuing_entity_country_code` = NA,
    `ucits` = NA,
    `replication_structure` = NA,
    `domicile` = NA,
    `base_currency` = NA,
    `listing_currency` = NA,
    `fund_listing_date` = NA,
    `listing_country_code` = NA,
    `listing_region` = NA,
    `smartvs_traditional_beta` = NA,
    `smartvs_traditional_beta_level2` = NA,
    `income_category` = NA,
    `etp_structure_type` = NA,
    `month_end_assets` = NA,
    `etf_portfolio_turnover` = NA,
    `firstbridge_id` = NA,
    `firstbridge_parent_id` = NA,
    `number_of_holdings` = NA,
    initialize = function(`id`, `name`, `ticker`, `figi_ticker`, `ric`, `isin`, `sedol`, `exchange_mic`, `sponsor`, `type`, `description`, `inception_date`, `data_change_date`, `close_date`, `is_live_listed`, `legal_structure`, `intraday_nav_ticker`, `primary_ticker`, `primary_ticker_country_code`, `primary_listing_region`, `net_expense_ratio`, `asset_class`, `other_asset_types`, `market_cap_range`, `holds_only_nyse_stocks`, `holds_only_nasdaq_stocks`, `growth_value_tilt`, `growth_type`, `value_type`, `sector`, `industry`, `sub_industry`, `cross_sector_theme`, `natural_resources_type`, `excludes_financials`, `excludes_technology`, `us_or_excludes_us`, `developed_emerging`, `specialized_region`, `continent`, `latin_america_sub_group`, `europe_sub_group`, `asia_sub_group`, `specific_country`, `china_listing_location`, `us_state`, `real_estate`, `index_weighting_scheme`, `market_cap_weighting_type`, `fundamental_weighting_type`, `dividend_weighting_type`, `bond_type`, `government_bond_types`, `municipal_bond_region`, `municipal_vrdo`, `mortgage_bond_types`, `bond_tax_status`, `credit_quality`, `average_maturity`, `specific_maturity_year`, `bond_currency_denomination`, `laddered`, `zero_coupon`, `floating_rate`, `build_america_bonds`, `commodity_types`, `energy_type`, `agricultural_type`, `metal_type`, `inverse_leveraged`, `target_date_multi_asset_type`, `currency_hedged`, `currency_pair`, `social_environmental_type`, `clean_energy_type`, `dividend_type`, `regular_dividend_payor_type`, `holds_ml_ps`, `holds_preferred_stock`, `holds_closed_end_funds`, `quant_strategies_type`, `other_quant_models`, `hedge_fund_type`, `derivatives_based`, `holds_ad_rs`, `index_linked`, `includes_short_exposure`, `index_name`, `parent_index`, `index_family`, `broader_index_family`, `index_provider`, `fund_family`, `index_ticker`, `etn_issuing_bank`, `etn_maturity_date`, `livestock`, `dynamic_futures_roll`, `index_provider_code`, `single_category_designation`, `registered_countries`, `issuing_entity_country_code`, `ucits`, `replication_structure`, `domicile`, `base_currency`, `listing_currency`, `fund_listing_date`, `listing_country_code`, `listing_region`, `smartvs_traditional_beta`, `smartvs_traditional_beta_level2`, `income_category`, `etp_structure_type`, `month_end_assets`, `etf_portfolio_turnover`, `firstbridge_id`, `firstbridge_parent_id`, `number_of_holdings`){
      if (!missing(`id`)) {
        self$`id` <- `id`
      }
      if (!missing(`name`)) {
        self$`name` <- `name`
      }
      if (!missing(`ticker`)) {
        self$`ticker` <- `ticker`
      }
      if (!missing(`figi_ticker`)) {
        self$`figi_ticker` <- `figi_ticker`
      }
      if (!missing(`ric`)) {
        self$`ric` <- `ric`
      }
      if (!missing(`isin`)) {
        self$`isin` <- `isin`
      }
      if (!missing(`sedol`)) {
        self$`sedol` <- `sedol`
      }
      if (!missing(`exchange_mic`)) {
        self$`exchange_mic` <- `exchange_mic`
      }
      if (!missing(`sponsor`)) {
        self$`sponsor` <- `sponsor`
      }
      if (!missing(`type`)) {
        self$`type` <- `type`
      }
      if (!missing(`description`)) {
        self$`description` <- `description`
      }
      if (!missing(`inception_date`)) {
        self$`inception_date` <- `inception_date`
      }
      if (!missing(`data_change_date`)) {
        self$`data_change_date` <- `data_change_date`
      }
      if (!missing(`close_date`)) {
        self$`close_date` <- `close_date`
      }
      if (!missing(`is_live_listed`)) {
        self$`is_live_listed` <- `is_live_listed`
      }
      if (!missing(`legal_structure`)) {
        self$`legal_structure` <- `legal_structure`
      }
      if (!missing(`intraday_nav_ticker`)) {
        self$`intraday_nav_ticker` <- `intraday_nav_ticker`
      }
      if (!missing(`primary_ticker`)) {
        self$`primary_ticker` <- `primary_ticker`
      }
      if (!missing(`primary_ticker_country_code`)) {
        self$`primary_ticker_country_code` <- `primary_ticker_country_code`
      }
      if (!missing(`primary_listing_region`)) {
        self$`primary_listing_region` <- `primary_listing_region`
      }
      if (!missing(`net_expense_ratio`)) {
        self$`net_expense_ratio` <- `net_expense_ratio`
      }
      if (!missing(`asset_class`)) {
        self$`asset_class` <- `asset_class`
      }
      if (!missing(`other_asset_types`)) {
        self$`other_asset_types` <- `other_asset_types`
      }
      if (!missing(`market_cap_range`)) {
        self$`market_cap_range` <- `market_cap_range`
      }
      if (!missing(`holds_only_nyse_stocks`)) {
        self$`holds_only_nyse_stocks` <- `holds_only_nyse_stocks`
      }
      if (!missing(`holds_only_nasdaq_stocks`)) {
        self$`holds_only_nasdaq_stocks` <- `holds_only_nasdaq_stocks`
      }
      if (!missing(`growth_value_tilt`)) {
        self$`growth_value_tilt` <- `growth_value_tilt`
      }
      if (!missing(`growth_type`)) {
        self$`growth_type` <- `growth_type`
      }
      if (!missing(`value_type`)) {
        self$`value_type` <- `value_type`
      }
      if (!missing(`sector`)) {
        self$`sector` <- `sector`
      }
      if (!missing(`industry`)) {
        self$`industry` <- `industry`
      }
      if (!missing(`sub_industry`)) {
        self$`sub_industry` <- `sub_industry`
      }
      if (!missing(`cross_sector_theme`)) {
        self$`cross_sector_theme` <- `cross_sector_theme`
      }
      if (!missing(`natural_resources_type`)) {
        self$`natural_resources_type` <- `natural_resources_type`
      }
      if (!missing(`excludes_financials`)) {
        self$`excludes_financials` <- `excludes_financials`
      }
      if (!missing(`excludes_technology`)) {
        self$`excludes_technology` <- `excludes_technology`
      }
      if (!missing(`us_or_excludes_us`)) {
        self$`us_or_excludes_us` <- `us_or_excludes_us`
      }
      if (!missing(`developed_emerging`)) {
        self$`developed_emerging` <- `developed_emerging`
      }
      if (!missing(`specialized_region`)) {
        self$`specialized_region` <- `specialized_region`
      }
      if (!missing(`continent`)) {
        self$`continent` <- `continent`
      }
      if (!missing(`latin_america_sub_group`)) {
        self$`latin_america_sub_group` <- `latin_america_sub_group`
      }
      if (!missing(`europe_sub_group`)) {
        self$`europe_sub_group` <- `europe_sub_group`
      }
      if (!missing(`asia_sub_group`)) {
        self$`asia_sub_group` <- `asia_sub_group`
      }
      if (!missing(`specific_country`)) {
        self$`specific_country` <- `specific_country`
      }
      if (!missing(`china_listing_location`)) {
        self$`china_listing_location` <- `china_listing_location`
      }
      if (!missing(`us_state`)) {
        self$`us_state` <- `us_state`
      }
      if (!missing(`real_estate`)) {
        self$`real_estate` <- `real_estate`
      }
      if (!missing(`index_weighting_scheme`)) {
        self$`index_weighting_scheme` <- `index_weighting_scheme`
      }
      if (!missing(`market_cap_weighting_type`)) {
        self$`market_cap_weighting_type` <- `market_cap_weighting_type`
      }
      if (!missing(`fundamental_weighting_type`)) {
        self$`fundamental_weighting_type` <- `fundamental_weighting_type`
      }
      if (!missing(`dividend_weighting_type`)) {
        self$`dividend_weighting_type` <- `dividend_weighting_type`
      }
      if (!missing(`bond_type`)) {
        self$`bond_type` <- `bond_type`
      }
      if (!missing(`government_bond_types`)) {
        self$`government_bond_types` <- `government_bond_types`
      }
      if (!missing(`municipal_bond_region`)) {
        self$`municipal_bond_region` <- `municipal_bond_region`
      }
      if (!missing(`municipal_vrdo`)) {
        self$`municipal_vrdo` <- `municipal_vrdo`
      }
      if (!missing(`mortgage_bond_types`)) {
        self$`mortgage_bond_types` <- `mortgage_bond_types`
      }
      if (!missing(`bond_tax_status`)) {
        self$`bond_tax_status` <- `bond_tax_status`
      }
      if (!missing(`credit_quality`)) {
        self$`credit_quality` <- `credit_quality`
      }
      if (!missing(`average_maturity`)) {
        self$`average_maturity` <- `average_maturity`
      }
      if (!missing(`specific_maturity_year`)) {
        self$`specific_maturity_year` <- `specific_maturity_year`
      }
      if (!missing(`bond_currency_denomination`)) {
        self$`bond_currency_denomination` <- `bond_currency_denomination`
      }
      if (!missing(`laddered`)) {
        self$`laddered` <- `laddered`
      }
      if (!missing(`zero_coupon`)) {
        self$`zero_coupon` <- `zero_coupon`
      }
      if (!missing(`floating_rate`)) {
        self$`floating_rate` <- `floating_rate`
      }
      if (!missing(`build_america_bonds`)) {
        self$`build_america_bonds` <- `build_america_bonds`
      }
      if (!missing(`commodity_types`)) {
        self$`commodity_types` <- `commodity_types`
      }
      if (!missing(`energy_type`)) {
        self$`energy_type` <- `energy_type`
      }
      if (!missing(`agricultural_type`)) {
        self$`agricultural_type` <- `agricultural_type`
      }
      if (!missing(`metal_type`)) {
        self$`metal_type` <- `metal_type`
      }
      if (!missing(`inverse_leveraged`)) {
        self$`inverse_leveraged` <- `inverse_leveraged`
      }
      if (!missing(`target_date_multi_asset_type`)) {
        self$`target_date_multi_asset_type` <- `target_date_multi_asset_type`
      }
      if (!missing(`currency_hedged`)) {
        self$`currency_hedged` <- `currency_hedged`
      }
      if (!missing(`currency_pair`)) {
        self$`currency_pair` <- `currency_pair`
      }
      if (!missing(`social_environmental_type`)) {
        self$`social_environmental_type` <- `social_environmental_type`
      }
      if (!missing(`clean_energy_type`)) {
        self$`clean_energy_type` <- `clean_energy_type`
      }
      if (!missing(`dividend_type`)) {
        self$`dividend_type` <- `dividend_type`
      }
      if (!missing(`regular_dividend_payor_type`)) {
        self$`regular_dividend_payor_type` <- `regular_dividend_payor_type`
      }
      if (!missing(`holds_ml_ps`)) {
        self$`holds_ml_ps` <- `holds_ml_ps`
      }
      if (!missing(`holds_preferred_stock`)) {
        self$`holds_preferred_stock` <- `holds_preferred_stock`
      }
      if (!missing(`holds_closed_end_funds`)) {
        self$`holds_closed_end_funds` <- `holds_closed_end_funds`
      }
      if (!missing(`quant_strategies_type`)) {
        self$`quant_strategies_type` <- `quant_strategies_type`
      }
      if (!missing(`other_quant_models`)) {
        self$`other_quant_models` <- `other_quant_models`
      }
      if (!missing(`hedge_fund_type`)) {
        self$`hedge_fund_type` <- `hedge_fund_type`
      }
      if (!missing(`derivatives_based`)) {
        self$`derivatives_based` <- `derivatives_based`
      }
      if (!missing(`holds_ad_rs`)) {
        self$`holds_ad_rs` <- `holds_ad_rs`
      }
      if (!missing(`index_linked`)) {
        self$`index_linked` <- `index_linked`
      }
      if (!missing(`includes_short_exposure`)) {
        self$`includes_short_exposure` <- `includes_short_exposure`
      }
      if (!missing(`index_name`)) {
        self$`index_name` <- `index_name`
      }
      if (!missing(`parent_index`)) {
        self$`parent_index` <- `parent_index`
      }
      if (!missing(`index_family`)) {
        self$`index_family` <- `index_family`
      }
      if (!missing(`broader_index_family`)) {
        self$`broader_index_family` <- `broader_index_family`
      }
      if (!missing(`index_provider`)) {
        self$`index_provider` <- `index_provider`
      }
      if (!missing(`fund_family`)) {
        self$`fund_family` <- `fund_family`
      }
      if (!missing(`index_ticker`)) {
        self$`index_ticker` <- `index_ticker`
      }
      if (!missing(`etn_issuing_bank`)) {
        self$`etn_issuing_bank` <- `etn_issuing_bank`
      }
      if (!missing(`etn_maturity_date`)) {
        self$`etn_maturity_date` <- `etn_maturity_date`
      }
      if (!missing(`livestock`)) {
        self$`livestock` <- `livestock`
      }
      if (!missing(`dynamic_futures_roll`)) {
        self$`dynamic_futures_roll` <- `dynamic_futures_roll`
      }
      if (!missing(`index_provider_code`)) {
        self$`index_provider_code` <- `index_provider_code`
      }
      if (!missing(`single_category_designation`)) {
        self$`single_category_designation` <- `single_category_designation`
      }
      if (!missing(`registered_countries`)) {
        self$`registered_countries` <- `registered_countries`
      }
      if (!missing(`issuing_entity_country_code`)) {
        self$`issuing_entity_country_code` <- `issuing_entity_country_code`
      }
      if (!missing(`ucits`)) {
        self$`ucits` <- `ucits`
      }
      if (!missing(`replication_structure`)) {
        self$`replication_structure` <- `replication_structure`
      }
      if (!missing(`domicile`)) {
        self$`domicile` <- `domicile`
      }
      if (!missing(`base_currency`)) {
        self$`base_currency` <- `base_currency`
      }
      if (!missing(`listing_currency`)) {
        self$`listing_currency` <- `listing_currency`
      }
      if (!missing(`fund_listing_date`)) {
        self$`fund_listing_date` <- `fund_listing_date`
      }
      if (!missing(`listing_country_code`)) {
        self$`listing_country_code` <- `listing_country_code`
      }
      if (!missing(`listing_region`)) {
        self$`listing_region` <- `listing_region`
      }
      if (!missing(`smartvs_traditional_beta`)) {
        self$`smartvs_traditional_beta` <- `smartvs_traditional_beta`
      }
      if (!missing(`smartvs_traditional_beta_level2`)) {
        self$`smartvs_traditional_beta_level2` <- `smartvs_traditional_beta_level2`
      }
      if (!missing(`income_category`)) {
        self$`income_category` <- `income_category`
      }
      if (!missing(`etp_structure_type`)) {
        self$`etp_structure_type` <- `etp_structure_type`
      }
      if (!missing(`month_end_assets`)) {
        self$`month_end_assets` <- `month_end_assets`
      }
      if (!missing(`etf_portfolio_turnover`)) {
        self$`etf_portfolio_turnover` <- `etf_portfolio_turnover`
      }
      if (!missing(`firstbridge_id`)) {
        self$`firstbridge_id` <- `firstbridge_id`
      }
      if (!missing(`firstbridge_parent_id`)) {
        self$`firstbridge_parent_id` <- `firstbridge_parent_id`
      }
      if (!missing(`number_of_holdings`)) {
        self$`number_of_holdings` <- `number_of_holdings`
      }
    },
    toJSON = function() {
      ETFObject <- list()
      if (!is.null(self$`id`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`id`) && ((length(self$`id`) == 0) || ((length(self$`id`) != 0 && R6::is.R6(self$`id`[[1]]))))) {
          ETFObject[['id']] <- lapply(self$`id`, function(x) x$toJSON())
        } else {
          ETFObject[['id']] <- jsonlite::toJSON(self$`id`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`name`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`name`) && ((length(self$`name`) == 0) || ((length(self$`name`) != 0 && R6::is.R6(self$`name`[[1]]))))) {
          ETFObject[['name']] <- lapply(self$`name`, function(x) x$toJSON())
        } else {
          ETFObject[['name']] <- jsonlite::toJSON(self$`name`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`ticker`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`ticker`) && ((length(self$`ticker`) == 0) || ((length(self$`ticker`) != 0 && R6::is.R6(self$`ticker`[[1]]))))) {
          ETFObject[['ticker']] <- lapply(self$`ticker`, function(x) x$toJSON())
        } else {
          ETFObject[['ticker']] <- jsonlite::toJSON(self$`ticker`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`figi_ticker`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`figi_ticker`) && ((length(self$`figi_ticker`) == 0) || ((length(self$`figi_ticker`) != 0 && R6::is.R6(self$`figi_ticker`[[1]]))))) {
          ETFObject[['figi_ticker']] <- lapply(self$`figi_ticker`, function(x) x$toJSON())
        } else {
          ETFObject[['figi_ticker']] <- jsonlite::toJSON(self$`figi_ticker`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`ric`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`ric`) && ((length(self$`ric`) == 0) || ((length(self$`ric`) != 0 && R6::is.R6(self$`ric`[[1]]))))) {
          ETFObject[['ric']] <- lapply(self$`ric`, function(x) x$toJSON())
        } else {
          ETFObject[['ric']] <- jsonlite::toJSON(self$`ric`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`isin`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`isin`) && ((length(self$`isin`) == 0) || ((length(self$`isin`) != 0 && R6::is.R6(self$`isin`[[1]]))))) {
          ETFObject[['isin']] <- lapply(self$`isin`, function(x) x$toJSON())
        } else {
          ETFObject[['isin']] <- jsonlite::toJSON(self$`isin`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`sedol`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`sedol`) && ((length(self$`sedol`) == 0) || ((length(self$`sedol`) != 0 && R6::is.R6(self$`sedol`[[1]]))))) {
          ETFObject[['sedol']] <- lapply(self$`sedol`, function(x) x$toJSON())
        } else {
          ETFObject[['sedol']] <- jsonlite::toJSON(self$`sedol`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`exchange_mic`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`exchange_mic`) && ((length(self$`exchange_mic`) == 0) || ((length(self$`exchange_mic`) != 0 && R6::is.R6(self$`exchange_mic`[[1]]))))) {
          ETFObject[['exchange_mic']] <- lapply(self$`exchange_mic`, function(x) x$toJSON())
        } else {
          ETFObject[['exchange_mic']] <- jsonlite::toJSON(self$`exchange_mic`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`sponsor`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`sponsor`) && ((length(self$`sponsor`) == 0) || ((length(self$`sponsor`) != 0 && R6::is.R6(self$`sponsor`[[1]]))))) {
          ETFObject[['sponsor']] <- lapply(self$`sponsor`, function(x) x$toJSON())
        } else {
          ETFObject[['sponsor']] <- jsonlite::toJSON(self$`sponsor`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`type`) && ((length(self$`type`) == 0) || ((length(self$`type`) != 0 && R6::is.R6(self$`type`[[1]]))))) {
          ETFObject[['type']] <- lapply(self$`type`, function(x) x$toJSON())
        } else {
          ETFObject[['type']] <- jsonlite::toJSON(self$`type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`description`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`description`) && ((length(self$`description`) == 0) || ((length(self$`description`) != 0 && R6::is.R6(self$`description`[[1]]))))) {
          ETFObject[['description']] <- lapply(self$`description`, function(x) x$toJSON())
        } else {
          ETFObject[['description']] <- jsonlite::toJSON(self$`description`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`inception_date`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`inception_date`) && ((length(self$`inception_date`) == 0) || ((length(self$`inception_date`) != 0 && R6::is.R6(self$`inception_date`[[1]]))))) {
          ETFObject[['inception_date']] <- lapply(self$`inception_date`, function(x) x$toJSON())
        } else {
          ETFObject[['inception_date']] <- jsonlite::toJSON(self$`inception_date`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`data_change_date`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`data_change_date`) && ((length(self$`data_change_date`) == 0) || ((length(self$`data_change_date`) != 0 && R6::is.R6(self$`data_change_date`[[1]]))))) {
          ETFObject[['data_change_date']] <- lapply(self$`data_change_date`, function(x) x$toJSON())
        } else {
          ETFObject[['data_change_date']] <- jsonlite::toJSON(self$`data_change_date`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`close_date`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`close_date`) && ((length(self$`close_date`) == 0) || ((length(self$`close_date`) != 0 && R6::is.R6(self$`close_date`[[1]]))))) {
          ETFObject[['close_date']] <- lapply(self$`close_date`, function(x) x$toJSON())
        } else {
          ETFObject[['close_date']] <- jsonlite::toJSON(self$`close_date`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`is_live_listed`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`is_live_listed`) && ((length(self$`is_live_listed`) == 0) || ((length(self$`is_live_listed`) != 0 && R6::is.R6(self$`is_live_listed`[[1]]))))) {
          ETFObject[['is_live_listed']] <- lapply(self$`is_live_listed`, function(x) x$toJSON())
        } else {
          ETFObject[['is_live_listed']] <- jsonlite::toJSON(self$`is_live_listed`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`legal_structure`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`legal_structure`) && ((length(self$`legal_structure`) == 0) || ((length(self$`legal_structure`) != 0 && R6::is.R6(self$`legal_structure`[[1]]))))) {
          ETFObject[['legal_structure']] <- lapply(self$`legal_structure`, function(x) x$toJSON())
        } else {
          ETFObject[['legal_structure']] <- jsonlite::toJSON(self$`legal_structure`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`intraday_nav_ticker`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`intraday_nav_ticker`) && ((length(self$`intraday_nav_ticker`) == 0) || ((length(self$`intraday_nav_ticker`) != 0 && R6::is.R6(self$`intraday_nav_ticker`[[1]]))))) {
          ETFObject[['intraday_nav_ticker']] <- lapply(self$`intraday_nav_ticker`, function(x) x$toJSON())
        } else {
          ETFObject[['intraday_nav_ticker']] <- jsonlite::toJSON(self$`intraday_nav_ticker`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`primary_ticker`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`primary_ticker`) && ((length(self$`primary_ticker`) == 0) || ((length(self$`primary_ticker`) != 0 && R6::is.R6(self$`primary_ticker`[[1]]))))) {
          ETFObject[['primary_ticker']] <- lapply(self$`primary_ticker`, function(x) x$toJSON())
        } else {
          ETFObject[['primary_ticker']] <- jsonlite::toJSON(self$`primary_ticker`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`primary_ticker_country_code`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`primary_ticker_country_code`) && ((length(self$`primary_ticker_country_code`) == 0) || ((length(self$`primary_ticker_country_code`) != 0 && R6::is.R6(self$`primary_ticker_country_code`[[1]]))))) {
          ETFObject[['primary_ticker_country_code']] <- lapply(self$`primary_ticker_country_code`, function(x) x$toJSON())
        } else {
          ETFObject[['primary_ticker_country_code']] <- jsonlite::toJSON(self$`primary_ticker_country_code`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`primary_listing_region`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`primary_listing_region`) && ((length(self$`primary_listing_region`) == 0) || ((length(self$`primary_listing_region`) != 0 && R6::is.R6(self$`primary_listing_region`[[1]]))))) {
          ETFObject[['primary_listing_region']] <- lapply(self$`primary_listing_region`, function(x) x$toJSON())
        } else {
          ETFObject[['primary_listing_region']] <- jsonlite::toJSON(self$`primary_listing_region`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`net_expense_ratio`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`net_expense_ratio`) && ((length(self$`net_expense_ratio`) == 0) || ((length(self$`net_expense_ratio`) != 0 && R6::is.R6(self$`net_expense_ratio`[[1]]))))) {
          ETFObject[['net_expense_ratio']] <- lapply(self$`net_expense_ratio`, function(x) x$toJSON())
        } else {
          ETFObject[['net_expense_ratio']] <- jsonlite::toJSON(self$`net_expense_ratio`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`asset_class`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`asset_class`) && ((length(self$`asset_class`) == 0) || ((length(self$`asset_class`) != 0 && R6::is.R6(self$`asset_class`[[1]]))))) {
          ETFObject[['asset_class']] <- lapply(self$`asset_class`, function(x) x$toJSON())
        } else {
          ETFObject[['asset_class']] <- jsonlite::toJSON(self$`asset_class`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`other_asset_types`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`other_asset_types`) && ((length(self$`other_asset_types`) == 0) || ((length(self$`other_asset_types`) != 0 && R6::is.R6(self$`other_asset_types`[[1]]))))) {
          ETFObject[['other_asset_types']] <- lapply(self$`other_asset_types`, function(x) x$toJSON())
        } else {
          ETFObject[['other_asset_types']] <- jsonlite::toJSON(self$`other_asset_types`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`market_cap_range`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`market_cap_range`) && ((length(self$`market_cap_range`) == 0) || ((length(self$`market_cap_range`) != 0 && R6::is.R6(self$`market_cap_range`[[1]]))))) {
          ETFObject[['market_cap_range']] <- lapply(self$`market_cap_range`, function(x) x$toJSON())
        } else {
          ETFObject[['market_cap_range']] <- jsonlite::toJSON(self$`market_cap_range`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`holds_only_nyse_stocks`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`holds_only_nyse_stocks`) && ((length(self$`holds_only_nyse_stocks`) == 0) || ((length(self$`holds_only_nyse_stocks`) != 0 && R6::is.R6(self$`holds_only_nyse_stocks`[[1]]))))) {
          ETFObject[['holds_only_nyse_stocks']] <- lapply(self$`holds_only_nyse_stocks`, function(x) x$toJSON())
        } else {
          ETFObject[['holds_only_nyse_stocks']] <- jsonlite::toJSON(self$`holds_only_nyse_stocks`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`holds_only_nasdaq_stocks`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`holds_only_nasdaq_stocks`) && ((length(self$`holds_only_nasdaq_stocks`) == 0) || ((length(self$`holds_only_nasdaq_stocks`) != 0 && R6::is.R6(self$`holds_only_nasdaq_stocks`[[1]]))))) {
          ETFObject[['holds_only_nasdaq_stocks']] <- lapply(self$`holds_only_nasdaq_stocks`, function(x) x$toJSON())
        } else {
          ETFObject[['holds_only_nasdaq_stocks']] <- jsonlite::toJSON(self$`holds_only_nasdaq_stocks`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`growth_value_tilt`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`growth_value_tilt`) && ((length(self$`growth_value_tilt`) == 0) || ((length(self$`growth_value_tilt`) != 0 && R6::is.R6(self$`growth_value_tilt`[[1]]))))) {
          ETFObject[['growth_value_tilt']] <- lapply(self$`growth_value_tilt`, function(x) x$toJSON())
        } else {
          ETFObject[['growth_value_tilt']] <- jsonlite::toJSON(self$`growth_value_tilt`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`growth_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`growth_type`) && ((length(self$`growth_type`) == 0) || ((length(self$`growth_type`) != 0 && R6::is.R6(self$`growth_type`[[1]]))))) {
          ETFObject[['growth_type']] <- lapply(self$`growth_type`, function(x) x$toJSON())
        } else {
          ETFObject[['growth_type']] <- jsonlite::toJSON(self$`growth_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`value_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`value_type`) && ((length(self$`value_type`) == 0) || ((length(self$`value_type`) != 0 && R6::is.R6(self$`value_type`[[1]]))))) {
          ETFObject[['value_type']] <- lapply(self$`value_type`, function(x) x$toJSON())
        } else {
          ETFObject[['value_type']] <- jsonlite::toJSON(self$`value_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`sector`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`sector`) && ((length(self$`sector`) == 0) || ((length(self$`sector`) != 0 && R6::is.R6(self$`sector`[[1]]))))) {
          ETFObject[['sector']] <- lapply(self$`sector`, function(x) x$toJSON())
        } else {
          ETFObject[['sector']] <- jsonlite::toJSON(self$`sector`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`industry`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`industry`) && ((length(self$`industry`) == 0) || ((length(self$`industry`) != 0 && R6::is.R6(self$`industry`[[1]]))))) {
          ETFObject[['industry']] <- lapply(self$`industry`, function(x) x$toJSON())
        } else {
          ETFObject[['industry']] <- jsonlite::toJSON(self$`industry`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`sub_industry`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`sub_industry`) && ((length(self$`sub_industry`) == 0) || ((length(self$`sub_industry`) != 0 && R6::is.R6(self$`sub_industry`[[1]]))))) {
          ETFObject[['sub_industry']] <- lapply(self$`sub_industry`, function(x) x$toJSON())
        } else {
          ETFObject[['sub_industry']] <- jsonlite::toJSON(self$`sub_industry`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`cross_sector_theme`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`cross_sector_theme`) && ((length(self$`cross_sector_theme`) == 0) || ((length(self$`cross_sector_theme`) != 0 && R6::is.R6(self$`cross_sector_theme`[[1]]))))) {
          ETFObject[['cross_sector_theme']] <- lapply(self$`cross_sector_theme`, function(x) x$toJSON())
        } else {
          ETFObject[['cross_sector_theme']] <- jsonlite::toJSON(self$`cross_sector_theme`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`natural_resources_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`natural_resources_type`) && ((length(self$`natural_resources_type`) == 0) || ((length(self$`natural_resources_type`) != 0 && R6::is.R6(self$`natural_resources_type`[[1]]))))) {
          ETFObject[['natural_resources_type']] <- lapply(self$`natural_resources_type`, function(x) x$toJSON())
        } else {
          ETFObject[['natural_resources_type']] <- jsonlite::toJSON(self$`natural_resources_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`excludes_financials`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`excludes_financials`) && ((length(self$`excludes_financials`) == 0) || ((length(self$`excludes_financials`) != 0 && R6::is.R6(self$`excludes_financials`[[1]]))))) {
          ETFObject[['excludes_financials']] <- lapply(self$`excludes_financials`, function(x) x$toJSON())
        } else {
          ETFObject[['excludes_financials']] <- jsonlite::toJSON(self$`excludes_financials`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`excludes_technology`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`excludes_technology`) && ((length(self$`excludes_technology`) == 0) || ((length(self$`excludes_technology`) != 0 && R6::is.R6(self$`excludes_technology`[[1]]))))) {
          ETFObject[['excludes_technology']] <- lapply(self$`excludes_technology`, function(x) x$toJSON())
        } else {
          ETFObject[['excludes_technology']] <- jsonlite::toJSON(self$`excludes_technology`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`us_or_excludes_us`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`us_or_excludes_us`) && ((length(self$`us_or_excludes_us`) == 0) || ((length(self$`us_or_excludes_us`) != 0 && R6::is.R6(self$`us_or_excludes_us`[[1]]))))) {
          ETFObject[['us_or_excludes_us']] <- lapply(self$`us_or_excludes_us`, function(x) x$toJSON())
        } else {
          ETFObject[['us_or_excludes_us']] <- jsonlite::toJSON(self$`us_or_excludes_us`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`developed_emerging`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`developed_emerging`) && ((length(self$`developed_emerging`) == 0) || ((length(self$`developed_emerging`) != 0 && R6::is.R6(self$`developed_emerging`[[1]]))))) {
          ETFObject[['developed_emerging']] <- lapply(self$`developed_emerging`, function(x) x$toJSON())
        } else {
          ETFObject[['developed_emerging']] <- jsonlite::toJSON(self$`developed_emerging`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`specialized_region`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`specialized_region`) && ((length(self$`specialized_region`) == 0) || ((length(self$`specialized_region`) != 0 && R6::is.R6(self$`specialized_region`[[1]]))))) {
          ETFObject[['specialized_region']] <- lapply(self$`specialized_region`, function(x) x$toJSON())
        } else {
          ETFObject[['specialized_region']] <- jsonlite::toJSON(self$`specialized_region`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`continent`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`continent`) && ((length(self$`continent`) == 0) || ((length(self$`continent`) != 0 && R6::is.R6(self$`continent`[[1]]))))) {
          ETFObject[['continent']] <- lapply(self$`continent`, function(x) x$toJSON())
        } else {
          ETFObject[['continent']] <- jsonlite::toJSON(self$`continent`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`latin_america_sub_group`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`latin_america_sub_group`) && ((length(self$`latin_america_sub_group`) == 0) || ((length(self$`latin_america_sub_group`) != 0 && R6::is.R6(self$`latin_america_sub_group`[[1]]))))) {
          ETFObject[['latin_america_sub_group']] <- lapply(self$`latin_america_sub_group`, function(x) x$toJSON())
        } else {
          ETFObject[['latin_america_sub_group']] <- jsonlite::toJSON(self$`latin_america_sub_group`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`europe_sub_group`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`europe_sub_group`) && ((length(self$`europe_sub_group`) == 0) || ((length(self$`europe_sub_group`) != 0 && R6::is.R6(self$`europe_sub_group`[[1]]))))) {
          ETFObject[['europe_sub_group']] <- lapply(self$`europe_sub_group`, function(x) x$toJSON())
        } else {
          ETFObject[['europe_sub_group']] <- jsonlite::toJSON(self$`europe_sub_group`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`asia_sub_group`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`asia_sub_group`) && ((length(self$`asia_sub_group`) == 0) || ((length(self$`asia_sub_group`) != 0 && R6::is.R6(self$`asia_sub_group`[[1]]))))) {
          ETFObject[['asia_sub_group']] <- lapply(self$`asia_sub_group`, function(x) x$toJSON())
        } else {
          ETFObject[['asia_sub_group']] <- jsonlite::toJSON(self$`asia_sub_group`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`specific_country`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`specific_country`) && ((length(self$`specific_country`) == 0) || ((length(self$`specific_country`) != 0 && R6::is.R6(self$`specific_country`[[1]]))))) {
          ETFObject[['specific_country']] <- lapply(self$`specific_country`, function(x) x$toJSON())
        } else {
          ETFObject[['specific_country']] <- jsonlite::toJSON(self$`specific_country`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`china_listing_location`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`china_listing_location`) && ((length(self$`china_listing_location`) == 0) || ((length(self$`china_listing_location`) != 0 && R6::is.R6(self$`china_listing_location`[[1]]))))) {
          ETFObject[['china_listing_location']] <- lapply(self$`china_listing_location`, function(x) x$toJSON())
        } else {
          ETFObject[['china_listing_location']] <- jsonlite::toJSON(self$`china_listing_location`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`us_state`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`us_state`) && ((length(self$`us_state`) == 0) || ((length(self$`us_state`) != 0 && R6::is.R6(self$`us_state`[[1]]))))) {
          ETFObject[['us_state']] <- lapply(self$`us_state`, function(x) x$toJSON())
        } else {
          ETFObject[['us_state']] <- jsonlite::toJSON(self$`us_state`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`real_estate`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`real_estate`) && ((length(self$`real_estate`) == 0) || ((length(self$`real_estate`) != 0 && R6::is.R6(self$`real_estate`[[1]]))))) {
          ETFObject[['real_estate']] <- lapply(self$`real_estate`, function(x) x$toJSON())
        } else {
          ETFObject[['real_estate']] <- jsonlite::toJSON(self$`real_estate`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`index_weighting_scheme`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`index_weighting_scheme`) && ((length(self$`index_weighting_scheme`) == 0) || ((length(self$`index_weighting_scheme`) != 0 && R6::is.R6(self$`index_weighting_scheme`[[1]]))))) {
          ETFObject[['index_weighting_scheme']] <- lapply(self$`index_weighting_scheme`, function(x) x$toJSON())
        } else {
          ETFObject[['index_weighting_scheme']] <- jsonlite::toJSON(self$`index_weighting_scheme`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`market_cap_weighting_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`market_cap_weighting_type`) && ((length(self$`market_cap_weighting_type`) == 0) || ((length(self$`market_cap_weighting_type`) != 0 && R6::is.R6(self$`market_cap_weighting_type`[[1]]))))) {
          ETFObject[['market_cap_weighting_type']] <- lapply(self$`market_cap_weighting_type`, function(x) x$toJSON())
        } else {
          ETFObject[['market_cap_weighting_type']] <- jsonlite::toJSON(self$`market_cap_weighting_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`fundamental_weighting_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`fundamental_weighting_type`) && ((length(self$`fundamental_weighting_type`) == 0) || ((length(self$`fundamental_weighting_type`) != 0 && R6::is.R6(self$`fundamental_weighting_type`[[1]]))))) {
          ETFObject[['fundamental_weighting_type']] <- lapply(self$`fundamental_weighting_type`, function(x) x$toJSON())
        } else {
          ETFObject[['fundamental_weighting_type']] <- jsonlite::toJSON(self$`fundamental_weighting_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`dividend_weighting_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`dividend_weighting_type`) && ((length(self$`dividend_weighting_type`) == 0) || ((length(self$`dividend_weighting_type`) != 0 && R6::is.R6(self$`dividend_weighting_type`[[1]]))))) {
          ETFObject[['dividend_weighting_type']] <- lapply(self$`dividend_weighting_type`, function(x) x$toJSON())
        } else {
          ETFObject[['dividend_weighting_type']] <- jsonlite::toJSON(self$`dividend_weighting_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`bond_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`bond_type`) && ((length(self$`bond_type`) == 0) || ((length(self$`bond_type`) != 0 && R6::is.R6(self$`bond_type`[[1]]))))) {
          ETFObject[['bond_type']] <- lapply(self$`bond_type`, function(x) x$toJSON())
        } else {
          ETFObject[['bond_type']] <- jsonlite::toJSON(self$`bond_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`government_bond_types`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`government_bond_types`) && ((length(self$`government_bond_types`) == 0) || ((length(self$`government_bond_types`) != 0 && R6::is.R6(self$`government_bond_types`[[1]]))))) {
          ETFObject[['government_bond_types']] <- lapply(self$`government_bond_types`, function(x) x$toJSON())
        } else {
          ETFObject[['government_bond_types']] <- jsonlite::toJSON(self$`government_bond_types`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`municipal_bond_region`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`municipal_bond_region`) && ((length(self$`municipal_bond_region`) == 0) || ((length(self$`municipal_bond_region`) != 0 && R6::is.R6(self$`municipal_bond_region`[[1]]))))) {
          ETFObject[['municipal_bond_region']] <- lapply(self$`municipal_bond_region`, function(x) x$toJSON())
        } else {
          ETFObject[['municipal_bond_region']] <- jsonlite::toJSON(self$`municipal_bond_region`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`municipal_vrdo`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`municipal_vrdo`) && ((length(self$`municipal_vrdo`) == 0) || ((length(self$`municipal_vrdo`) != 0 && R6::is.R6(self$`municipal_vrdo`[[1]]))))) {
          ETFObject[['municipal_vrdo']] <- lapply(self$`municipal_vrdo`, function(x) x$toJSON())
        } else {
          ETFObject[['municipal_vrdo']] <- jsonlite::toJSON(self$`municipal_vrdo`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`mortgage_bond_types`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`mortgage_bond_types`) && ((length(self$`mortgage_bond_types`) == 0) || ((length(self$`mortgage_bond_types`) != 0 && R6::is.R6(self$`mortgage_bond_types`[[1]]))))) {
          ETFObject[['mortgage_bond_types']] <- lapply(self$`mortgage_bond_types`, function(x) x$toJSON())
        } else {
          ETFObject[['mortgage_bond_types']] <- jsonlite::toJSON(self$`mortgage_bond_types`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`bond_tax_status`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`bond_tax_status`) && ((length(self$`bond_tax_status`) == 0) || ((length(self$`bond_tax_status`) != 0 && R6::is.R6(self$`bond_tax_status`[[1]]))))) {
          ETFObject[['bond_tax_status']] <- lapply(self$`bond_tax_status`, function(x) x$toJSON())
        } else {
          ETFObject[['bond_tax_status']] <- jsonlite::toJSON(self$`bond_tax_status`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`credit_quality`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`credit_quality`) && ((length(self$`credit_quality`) == 0) || ((length(self$`credit_quality`) != 0 && R6::is.R6(self$`credit_quality`[[1]]))))) {
          ETFObject[['credit_quality']] <- lapply(self$`credit_quality`, function(x) x$toJSON())
        } else {
          ETFObject[['credit_quality']] <- jsonlite::toJSON(self$`credit_quality`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`average_maturity`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`average_maturity`) && ((length(self$`average_maturity`) == 0) || ((length(self$`average_maturity`) != 0 && R6::is.R6(self$`average_maturity`[[1]]))))) {
          ETFObject[['average_maturity']] <- lapply(self$`average_maturity`, function(x) x$toJSON())
        } else {
          ETFObject[['average_maturity']] <- jsonlite::toJSON(self$`average_maturity`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`specific_maturity_year`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`specific_maturity_year`) && ((length(self$`specific_maturity_year`) == 0) || ((length(self$`specific_maturity_year`) != 0 && R6::is.R6(self$`specific_maturity_year`[[1]]))))) {
          ETFObject[['specific_maturity_year']] <- lapply(self$`specific_maturity_year`, function(x) x$toJSON())
        } else {
          ETFObject[['specific_maturity_year']] <- jsonlite::toJSON(self$`specific_maturity_year`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`bond_currency_denomination`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`bond_currency_denomination`) && ((length(self$`bond_currency_denomination`) == 0) || ((length(self$`bond_currency_denomination`) != 0 && R6::is.R6(self$`bond_currency_denomination`[[1]]))))) {
          ETFObject[['bond_currency_denomination']] <- lapply(self$`bond_currency_denomination`, function(x) x$toJSON())
        } else {
          ETFObject[['bond_currency_denomination']] <- jsonlite::toJSON(self$`bond_currency_denomination`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`laddered`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`laddered`) && ((length(self$`laddered`) == 0) || ((length(self$`laddered`) != 0 && R6::is.R6(self$`laddered`[[1]]))))) {
          ETFObject[['laddered']] <- lapply(self$`laddered`, function(x) x$toJSON())
        } else {
          ETFObject[['laddered']] <- jsonlite::toJSON(self$`laddered`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`zero_coupon`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`zero_coupon`) && ((length(self$`zero_coupon`) == 0) || ((length(self$`zero_coupon`) != 0 && R6::is.R6(self$`zero_coupon`[[1]]))))) {
          ETFObject[['zero_coupon']] <- lapply(self$`zero_coupon`, function(x) x$toJSON())
        } else {
          ETFObject[['zero_coupon']] <- jsonlite::toJSON(self$`zero_coupon`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`floating_rate`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`floating_rate`) && ((length(self$`floating_rate`) == 0) || ((length(self$`floating_rate`) != 0 && R6::is.R6(self$`floating_rate`[[1]]))))) {
          ETFObject[['floating_rate']] <- lapply(self$`floating_rate`, function(x) x$toJSON())
        } else {
          ETFObject[['floating_rate']] <- jsonlite::toJSON(self$`floating_rate`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`build_america_bonds`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`build_america_bonds`) && ((length(self$`build_america_bonds`) == 0) || ((length(self$`build_america_bonds`) != 0 && R6::is.R6(self$`build_america_bonds`[[1]]))))) {
          ETFObject[['build_america_bonds']] <- lapply(self$`build_america_bonds`, function(x) x$toJSON())
        } else {
          ETFObject[['build_america_bonds']] <- jsonlite::toJSON(self$`build_america_bonds`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`commodity_types`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`commodity_types`) && ((length(self$`commodity_types`) == 0) || ((length(self$`commodity_types`) != 0 && R6::is.R6(self$`commodity_types`[[1]]))))) {
          ETFObject[['commodity_types']] <- lapply(self$`commodity_types`, function(x) x$toJSON())
        } else {
          ETFObject[['commodity_types']] <- jsonlite::toJSON(self$`commodity_types`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`energy_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`energy_type`) && ((length(self$`energy_type`) == 0) || ((length(self$`energy_type`) != 0 && R6::is.R6(self$`energy_type`[[1]]))))) {
          ETFObject[['energy_type']] <- lapply(self$`energy_type`, function(x) x$toJSON())
        } else {
          ETFObject[['energy_type']] <- jsonlite::toJSON(self$`energy_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`agricultural_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`agricultural_type`) && ((length(self$`agricultural_type`) == 0) || ((length(self$`agricultural_type`) != 0 && R6::is.R6(self$`agricultural_type`[[1]]))))) {
          ETFObject[['agricultural_type']] <- lapply(self$`agricultural_type`, function(x) x$toJSON())
        } else {
          ETFObject[['agricultural_type']] <- jsonlite::toJSON(self$`agricultural_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`metal_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`metal_type`) && ((length(self$`metal_type`) == 0) || ((length(self$`metal_type`) != 0 && R6::is.R6(self$`metal_type`[[1]]))))) {
          ETFObject[['metal_type']] <- lapply(self$`metal_type`, function(x) x$toJSON())
        } else {
          ETFObject[['metal_type']] <- jsonlite::toJSON(self$`metal_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`inverse_leveraged`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`inverse_leveraged`) && ((length(self$`inverse_leveraged`) == 0) || ((length(self$`inverse_leveraged`) != 0 && R6::is.R6(self$`inverse_leveraged`[[1]]))))) {
          ETFObject[['inverse_leveraged']] <- lapply(self$`inverse_leveraged`, function(x) x$toJSON())
        } else {
          ETFObject[['inverse_leveraged']] <- jsonlite::toJSON(self$`inverse_leveraged`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`target_date_multi_asset_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`target_date_multi_asset_type`) && ((length(self$`target_date_multi_asset_type`) == 0) || ((length(self$`target_date_multi_asset_type`) != 0 && R6::is.R6(self$`target_date_multi_asset_type`[[1]]))))) {
          ETFObject[['target_date_multi_asset_type']] <- lapply(self$`target_date_multi_asset_type`, function(x) x$toJSON())
        } else {
          ETFObject[['target_date_multi_asset_type']] <- jsonlite::toJSON(self$`target_date_multi_asset_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`currency_hedged`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`currency_hedged`) && ((length(self$`currency_hedged`) == 0) || ((length(self$`currency_hedged`) != 0 && R6::is.R6(self$`currency_hedged`[[1]]))))) {
          ETFObject[['currency_hedged']] <- lapply(self$`currency_hedged`, function(x) x$toJSON())
        } else {
          ETFObject[['currency_hedged']] <- jsonlite::toJSON(self$`currency_hedged`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`currency_pair`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`currency_pair`) && ((length(self$`currency_pair`) == 0) || ((length(self$`currency_pair`) != 0 && R6::is.R6(self$`currency_pair`[[1]]))))) {
          ETFObject[['currency_pair']] <- lapply(self$`currency_pair`, function(x) x$toJSON())
        } else {
          ETFObject[['currency_pair']] <- jsonlite::toJSON(self$`currency_pair`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`social_environmental_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`social_environmental_type`) && ((length(self$`social_environmental_type`) == 0) || ((length(self$`social_environmental_type`) != 0 && R6::is.R6(self$`social_environmental_type`[[1]]))))) {
          ETFObject[['social_environmental_type']] <- lapply(self$`social_environmental_type`, function(x) x$toJSON())
        } else {
          ETFObject[['social_environmental_type']] <- jsonlite::toJSON(self$`social_environmental_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`clean_energy_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`clean_energy_type`) && ((length(self$`clean_energy_type`) == 0) || ((length(self$`clean_energy_type`) != 0 && R6::is.R6(self$`clean_energy_type`[[1]]))))) {
          ETFObject[['clean_energy_type']] <- lapply(self$`clean_energy_type`, function(x) x$toJSON())
        } else {
          ETFObject[['clean_energy_type']] <- jsonlite::toJSON(self$`clean_energy_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`dividend_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`dividend_type`) && ((length(self$`dividend_type`) == 0) || ((length(self$`dividend_type`) != 0 && R6::is.R6(self$`dividend_type`[[1]]))))) {
          ETFObject[['dividend_type']] <- lapply(self$`dividend_type`, function(x) x$toJSON())
        } else {
          ETFObject[['dividend_type']] <- jsonlite::toJSON(self$`dividend_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`regular_dividend_payor_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`regular_dividend_payor_type`) && ((length(self$`regular_dividend_payor_type`) == 0) || ((length(self$`regular_dividend_payor_type`) != 0 && R6::is.R6(self$`regular_dividend_payor_type`[[1]]))))) {
          ETFObject[['regular_dividend_payor_type']] <- lapply(self$`regular_dividend_payor_type`, function(x) x$toJSON())
        } else {
          ETFObject[['regular_dividend_payor_type']] <- jsonlite::toJSON(self$`regular_dividend_payor_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`holds_ml_ps`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`holds_ml_ps`) && ((length(self$`holds_ml_ps`) == 0) || ((length(self$`holds_ml_ps`) != 0 && R6::is.R6(self$`holds_ml_ps`[[1]]))))) {
          ETFObject[['holds_ml_ps']] <- lapply(self$`holds_ml_ps`, function(x) x$toJSON())
        } else {
          ETFObject[['holds_ml_ps']] <- jsonlite::toJSON(self$`holds_ml_ps`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`holds_preferred_stock`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`holds_preferred_stock`) && ((length(self$`holds_preferred_stock`) == 0) || ((length(self$`holds_preferred_stock`) != 0 && R6::is.R6(self$`holds_preferred_stock`[[1]]))))) {
          ETFObject[['holds_preferred_stock']] <- lapply(self$`holds_preferred_stock`, function(x) x$toJSON())
        } else {
          ETFObject[['holds_preferred_stock']] <- jsonlite::toJSON(self$`holds_preferred_stock`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`holds_closed_end_funds`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`holds_closed_end_funds`) && ((length(self$`holds_closed_end_funds`) == 0) || ((length(self$`holds_closed_end_funds`) != 0 && R6::is.R6(self$`holds_closed_end_funds`[[1]]))))) {
          ETFObject[['holds_closed_end_funds']] <- lapply(self$`holds_closed_end_funds`, function(x) x$toJSON())
        } else {
          ETFObject[['holds_closed_end_funds']] <- jsonlite::toJSON(self$`holds_closed_end_funds`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`quant_strategies_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`quant_strategies_type`) && ((length(self$`quant_strategies_type`) == 0) || ((length(self$`quant_strategies_type`) != 0 && R6::is.R6(self$`quant_strategies_type`[[1]]))))) {
          ETFObject[['quant_strategies_type']] <- lapply(self$`quant_strategies_type`, function(x) x$toJSON())
        } else {
          ETFObject[['quant_strategies_type']] <- jsonlite::toJSON(self$`quant_strategies_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`other_quant_models`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`other_quant_models`) && ((length(self$`other_quant_models`) == 0) || ((length(self$`other_quant_models`) != 0 && R6::is.R6(self$`other_quant_models`[[1]]))))) {
          ETFObject[['other_quant_models']] <- lapply(self$`other_quant_models`, function(x) x$toJSON())
        } else {
          ETFObject[['other_quant_models']] <- jsonlite::toJSON(self$`other_quant_models`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`hedge_fund_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`hedge_fund_type`) && ((length(self$`hedge_fund_type`) == 0) || ((length(self$`hedge_fund_type`) != 0 && R6::is.R6(self$`hedge_fund_type`[[1]]))))) {
          ETFObject[['hedge_fund_type']] <- lapply(self$`hedge_fund_type`, function(x) x$toJSON())
        } else {
          ETFObject[['hedge_fund_type']] <- jsonlite::toJSON(self$`hedge_fund_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`derivatives_based`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`derivatives_based`) && ((length(self$`derivatives_based`) == 0) || ((length(self$`derivatives_based`) != 0 && R6::is.R6(self$`derivatives_based`[[1]]))))) {
          ETFObject[['derivatives_based']] <- lapply(self$`derivatives_based`, function(x) x$toJSON())
        } else {
          ETFObject[['derivatives_based']] <- jsonlite::toJSON(self$`derivatives_based`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`holds_ad_rs`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`holds_ad_rs`) && ((length(self$`holds_ad_rs`) == 0) || ((length(self$`holds_ad_rs`) != 0 && R6::is.R6(self$`holds_ad_rs`[[1]]))))) {
          ETFObject[['holds_ad_rs']] <- lapply(self$`holds_ad_rs`, function(x) x$toJSON())
        } else {
          ETFObject[['holds_ad_rs']] <- jsonlite::toJSON(self$`holds_ad_rs`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`index_linked`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`index_linked`) && ((length(self$`index_linked`) == 0) || ((length(self$`index_linked`) != 0 && R6::is.R6(self$`index_linked`[[1]]))))) {
          ETFObject[['index_linked']] <- lapply(self$`index_linked`, function(x) x$toJSON())
        } else {
          ETFObject[['index_linked']] <- jsonlite::toJSON(self$`index_linked`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`includes_short_exposure`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`includes_short_exposure`) && ((length(self$`includes_short_exposure`) == 0) || ((length(self$`includes_short_exposure`) != 0 && R6::is.R6(self$`includes_short_exposure`[[1]]))))) {
          ETFObject[['includes_short_exposure']] <- lapply(self$`includes_short_exposure`, function(x) x$toJSON())
        } else {
          ETFObject[['includes_short_exposure']] <- jsonlite::toJSON(self$`includes_short_exposure`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`index_name`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`index_name`) && ((length(self$`index_name`) == 0) || ((length(self$`index_name`) != 0 && R6::is.R6(self$`index_name`[[1]]))))) {
          ETFObject[['index_name']] <- lapply(self$`index_name`, function(x) x$toJSON())
        } else {
          ETFObject[['index_name']] <- jsonlite::toJSON(self$`index_name`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`parent_index`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`parent_index`) && ((length(self$`parent_index`) == 0) || ((length(self$`parent_index`) != 0 && R6::is.R6(self$`parent_index`[[1]]))))) {
          ETFObject[['parent_index']] <- lapply(self$`parent_index`, function(x) x$toJSON())
        } else {
          ETFObject[['parent_index']] <- jsonlite::toJSON(self$`parent_index`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`index_family`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`index_family`) && ((length(self$`index_family`) == 0) || ((length(self$`index_family`) != 0 && R6::is.R6(self$`index_family`[[1]]))))) {
          ETFObject[['index_family']] <- lapply(self$`index_family`, function(x) x$toJSON())
        } else {
          ETFObject[['index_family']] <- jsonlite::toJSON(self$`index_family`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`broader_index_family`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`broader_index_family`) && ((length(self$`broader_index_family`) == 0) || ((length(self$`broader_index_family`) != 0 && R6::is.R6(self$`broader_index_family`[[1]]))))) {
          ETFObject[['broader_index_family']] <- lapply(self$`broader_index_family`, function(x) x$toJSON())
        } else {
          ETFObject[['broader_index_family']] <- jsonlite::toJSON(self$`broader_index_family`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`index_provider`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`index_provider`) && ((length(self$`index_provider`) == 0) || ((length(self$`index_provider`) != 0 && R6::is.R6(self$`index_provider`[[1]]))))) {
          ETFObject[['index_provider']] <- lapply(self$`index_provider`, function(x) x$toJSON())
        } else {
          ETFObject[['index_provider']] <- jsonlite::toJSON(self$`index_provider`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`fund_family`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`fund_family`) && ((length(self$`fund_family`) == 0) || ((length(self$`fund_family`) != 0 && R6::is.R6(self$`fund_family`[[1]]))))) {
          ETFObject[['fund_family']] <- lapply(self$`fund_family`, function(x) x$toJSON())
        } else {
          ETFObject[['fund_family']] <- jsonlite::toJSON(self$`fund_family`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`index_ticker`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`index_ticker`) && ((length(self$`index_ticker`) == 0) || ((length(self$`index_ticker`) != 0 && R6::is.R6(self$`index_ticker`[[1]]))))) {
          ETFObject[['index_ticker']] <- lapply(self$`index_ticker`, function(x) x$toJSON())
        } else {
          ETFObject[['index_ticker']] <- jsonlite::toJSON(self$`index_ticker`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`etn_issuing_bank`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`etn_issuing_bank`) && ((length(self$`etn_issuing_bank`) == 0) || ((length(self$`etn_issuing_bank`) != 0 && R6::is.R6(self$`etn_issuing_bank`[[1]]))))) {
          ETFObject[['etn_issuing_bank']] <- lapply(self$`etn_issuing_bank`, function(x) x$toJSON())
        } else {
          ETFObject[['etn_issuing_bank']] <- jsonlite::toJSON(self$`etn_issuing_bank`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`etn_maturity_date`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`etn_maturity_date`) && ((length(self$`etn_maturity_date`) == 0) || ((length(self$`etn_maturity_date`) != 0 && R6::is.R6(self$`etn_maturity_date`[[1]]))))) {
          ETFObject[['etn_maturity_date']] <- lapply(self$`etn_maturity_date`, function(x) x$toJSON())
        } else {
          ETFObject[['etn_maturity_date']] <- jsonlite::toJSON(self$`etn_maturity_date`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`livestock`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`livestock`) && ((length(self$`livestock`) == 0) || ((length(self$`livestock`) != 0 && R6::is.R6(self$`livestock`[[1]]))))) {
          ETFObject[['livestock']] <- lapply(self$`livestock`, function(x) x$toJSON())
        } else {
          ETFObject[['livestock']] <- jsonlite::toJSON(self$`livestock`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`dynamic_futures_roll`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`dynamic_futures_roll`) && ((length(self$`dynamic_futures_roll`) == 0) || ((length(self$`dynamic_futures_roll`) != 0 && R6::is.R6(self$`dynamic_futures_roll`[[1]]))))) {
          ETFObject[['dynamic_futures_roll']] <- lapply(self$`dynamic_futures_roll`, function(x) x$toJSON())
        } else {
          ETFObject[['dynamic_futures_roll']] <- jsonlite::toJSON(self$`dynamic_futures_roll`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`index_provider_code`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`index_provider_code`) && ((length(self$`index_provider_code`) == 0) || ((length(self$`index_provider_code`) != 0 && R6::is.R6(self$`index_provider_code`[[1]]))))) {
          ETFObject[['index_provider_code']] <- lapply(self$`index_provider_code`, function(x) x$toJSON())
        } else {
          ETFObject[['index_provider_code']] <- jsonlite::toJSON(self$`index_provider_code`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`single_category_designation`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`single_category_designation`) && ((length(self$`single_category_designation`) == 0) || ((length(self$`single_category_designation`) != 0 && R6::is.R6(self$`single_category_designation`[[1]]))))) {
          ETFObject[['single_category_designation']] <- lapply(self$`single_category_designation`, function(x) x$toJSON())
        } else {
          ETFObject[['single_category_designation']] <- jsonlite::toJSON(self$`single_category_designation`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`registered_countries`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`registered_countries`) && ((length(self$`registered_countries`) == 0) || ((length(self$`registered_countries`) != 0 && R6::is.R6(self$`registered_countries`[[1]]))))) {
          ETFObject[['registered_countries']] <- lapply(self$`registered_countries`, function(x) x$toJSON())
        } else {
          ETFObject[['registered_countries']] <- jsonlite::toJSON(self$`registered_countries`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`issuing_entity_country_code`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`issuing_entity_country_code`) && ((length(self$`issuing_entity_country_code`) == 0) || ((length(self$`issuing_entity_country_code`) != 0 && R6::is.R6(self$`issuing_entity_country_code`[[1]]))))) {
          ETFObject[['issuing_entity_country_code']] <- lapply(self$`issuing_entity_country_code`, function(x) x$toJSON())
        } else {
          ETFObject[['issuing_entity_country_code']] <- jsonlite::toJSON(self$`issuing_entity_country_code`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`ucits`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`ucits`) && ((length(self$`ucits`) == 0) || ((length(self$`ucits`) != 0 && R6::is.R6(self$`ucits`[[1]]))))) {
          ETFObject[['ucits']] <- lapply(self$`ucits`, function(x) x$toJSON())
        } else {
          ETFObject[['ucits']] <- jsonlite::toJSON(self$`ucits`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`replication_structure`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`replication_structure`) && ((length(self$`replication_structure`) == 0) || ((length(self$`replication_structure`) != 0 && R6::is.R6(self$`replication_structure`[[1]]))))) {
          ETFObject[['replication_structure']] <- lapply(self$`replication_structure`, function(x) x$toJSON())
        } else {
          ETFObject[['replication_structure']] <- jsonlite::toJSON(self$`replication_structure`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`domicile`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`domicile`) && ((length(self$`domicile`) == 0) || ((length(self$`domicile`) != 0 && R6::is.R6(self$`domicile`[[1]]))))) {
          ETFObject[['domicile']] <- lapply(self$`domicile`, function(x) x$toJSON())
        } else {
          ETFObject[['domicile']] <- jsonlite::toJSON(self$`domicile`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`base_currency`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`base_currency`) && ((length(self$`base_currency`) == 0) || ((length(self$`base_currency`) != 0 && R6::is.R6(self$`base_currency`[[1]]))))) {
          ETFObject[['base_currency']] <- lapply(self$`base_currency`, function(x) x$toJSON())
        } else {
          ETFObject[['base_currency']] <- jsonlite::toJSON(self$`base_currency`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`listing_currency`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`listing_currency`) && ((length(self$`listing_currency`) == 0) || ((length(self$`listing_currency`) != 0 && R6::is.R6(self$`listing_currency`[[1]]))))) {
          ETFObject[['listing_currency']] <- lapply(self$`listing_currency`, function(x) x$toJSON())
        } else {
          ETFObject[['listing_currency']] <- jsonlite::toJSON(self$`listing_currency`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`fund_listing_date`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`fund_listing_date`) && ((length(self$`fund_listing_date`) == 0) || ((length(self$`fund_listing_date`) != 0 && R6::is.R6(self$`fund_listing_date`[[1]]))))) {
          ETFObject[['fund_listing_date']] <- lapply(self$`fund_listing_date`, function(x) x$toJSON())
        } else {
          ETFObject[['fund_listing_date']] <- jsonlite::toJSON(self$`fund_listing_date`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`listing_country_code`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`listing_country_code`) && ((length(self$`listing_country_code`) == 0) || ((length(self$`listing_country_code`) != 0 && R6::is.R6(self$`listing_country_code`[[1]]))))) {
          ETFObject[['listing_country_code']] <- lapply(self$`listing_country_code`, function(x) x$toJSON())
        } else {
          ETFObject[['listing_country_code']] <- jsonlite::toJSON(self$`listing_country_code`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`listing_region`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`listing_region`) && ((length(self$`listing_region`) == 0) || ((length(self$`listing_region`) != 0 && R6::is.R6(self$`listing_region`[[1]]))))) {
          ETFObject[['listing_region']] <- lapply(self$`listing_region`, function(x) x$toJSON())
        } else {
          ETFObject[['listing_region']] <- jsonlite::toJSON(self$`listing_region`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`smartvs_traditional_beta`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`smartvs_traditional_beta`) && ((length(self$`smartvs_traditional_beta`) == 0) || ((length(self$`smartvs_traditional_beta`) != 0 && R6::is.R6(self$`smartvs_traditional_beta`[[1]]))))) {
          ETFObject[['smartvs_traditional_beta']] <- lapply(self$`smartvs_traditional_beta`, function(x) x$toJSON())
        } else {
          ETFObject[['smartvs_traditional_beta']] <- jsonlite::toJSON(self$`smartvs_traditional_beta`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`smartvs_traditional_beta_level2`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`smartvs_traditional_beta_level2`) && ((length(self$`smartvs_traditional_beta_level2`) == 0) || ((length(self$`smartvs_traditional_beta_level2`) != 0 && R6::is.R6(self$`smartvs_traditional_beta_level2`[[1]]))))) {
          ETFObject[['smartvs_traditional_beta_level2']] <- lapply(self$`smartvs_traditional_beta_level2`, function(x) x$toJSON())
        } else {
          ETFObject[['smartvs_traditional_beta_level2']] <- jsonlite::toJSON(self$`smartvs_traditional_beta_level2`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`income_category`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`income_category`) && ((length(self$`income_category`) == 0) || ((length(self$`income_category`) != 0 && R6::is.R6(self$`income_category`[[1]]))))) {
          ETFObject[['income_category']] <- lapply(self$`income_category`, function(x) x$toJSON())
        } else {
          ETFObject[['income_category']] <- jsonlite::toJSON(self$`income_category`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`etp_structure_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`etp_structure_type`) && ((length(self$`etp_structure_type`) == 0) || ((length(self$`etp_structure_type`) != 0 && R6::is.R6(self$`etp_structure_type`[[1]]))))) {
          ETFObject[['etp_structure_type']] <- lapply(self$`etp_structure_type`, function(x) x$toJSON())
        } else {
          ETFObject[['etp_structure_type']] <- jsonlite::toJSON(self$`etp_structure_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`month_end_assets`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`month_end_assets`) && ((length(self$`month_end_assets`) == 0) || ((length(self$`month_end_assets`) != 0 && R6::is.R6(self$`month_end_assets`[[1]]))))) {
          ETFObject[['month_end_assets']] <- lapply(self$`month_end_assets`, function(x) x$toJSON())
        } else {
          ETFObject[['month_end_assets']] <- jsonlite::toJSON(self$`month_end_assets`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`etf_portfolio_turnover`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`etf_portfolio_turnover`) && ((length(self$`etf_portfolio_turnover`) == 0) || ((length(self$`etf_portfolio_turnover`) != 0 && R6::is.R6(self$`etf_portfolio_turnover`[[1]]))))) {
          ETFObject[['etf_portfolio_turnover']] <- lapply(self$`etf_portfolio_turnover`, function(x) x$toJSON())
        } else {
          ETFObject[['etf_portfolio_turnover']] <- jsonlite::toJSON(self$`etf_portfolio_turnover`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`firstbridge_id`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`firstbridge_id`) && ((length(self$`firstbridge_id`) == 0) || ((length(self$`firstbridge_id`) != 0 && R6::is.R6(self$`firstbridge_id`[[1]]))))) {
          ETFObject[['firstbridge_id']] <- lapply(self$`firstbridge_id`, function(x) x$toJSON())
        } else {
          ETFObject[['firstbridge_id']] <- jsonlite::toJSON(self$`firstbridge_id`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`firstbridge_parent_id`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`firstbridge_parent_id`) && ((length(self$`firstbridge_parent_id`) == 0) || ((length(self$`firstbridge_parent_id`) != 0 && R6::is.R6(self$`firstbridge_parent_id`[[1]]))))) {
          ETFObject[['firstbridge_parent_id']] <- lapply(self$`firstbridge_parent_id`, function(x) x$toJSON())
        } else {
          ETFObject[['firstbridge_parent_id']] <- jsonlite::toJSON(self$`firstbridge_parent_id`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`number_of_holdings`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`number_of_holdings`) && ((length(self$`number_of_holdings`) == 0) || ((length(self$`number_of_holdings`) != 0 && R6::is.R6(self$`number_of_holdings`[[1]]))))) {
          ETFObject[['number_of_holdings']] <- lapply(self$`number_of_holdings`, function(x) x$toJSON())
        } else {
          ETFObject[['number_of_holdings']] <- jsonlite::toJSON(self$`number_of_holdings`, auto_unbox = TRUE)
        }
      }

      ETFObject
    },
    fromJSON = function(ETFJson) {
      ETFObject <- jsonlite::fromJSON(ETFJson)
      if (!is.null(ETFObject$`id`)) {
        self$`id` <- ETFObject$`id`
      }
      if (!is.null(ETFObject$`name`)) {
        self$`name` <- ETFObject$`name`
      }
      if (!is.null(ETFObject$`ticker`)) {
        self$`ticker` <- ETFObject$`ticker`
      }
      if (!is.null(ETFObject$`figi_ticker`)) {
        self$`figi_ticker` <- ETFObject$`figi_ticker`
      }
      if (!is.null(ETFObject$`ric`)) {
        self$`ric` <- ETFObject$`ric`
      }
      if (!is.null(ETFObject$`isin`)) {
        self$`isin` <- ETFObject$`isin`
      }
      if (!is.null(ETFObject$`sedol`)) {
        self$`sedol` <- ETFObject$`sedol`
      }
      if (!is.null(ETFObject$`exchange_mic`)) {
        self$`exchange_mic` <- ETFObject$`exchange_mic`
      }
      if (!is.null(ETFObject$`sponsor`)) {
        self$`sponsor` <- ETFObject$`sponsor`
      }
      if (!is.null(ETFObject$`type`)) {
        self$`type` <- ETFObject$`type`
      }
      if (!is.null(ETFObject$`description`)) {
        self$`description` <- ETFObject$`description`
      }
      if (!is.null(ETFObject$`inception_date`)) {
        self$`inception_date` <- ETFObject$`inception_date`
      }
      if (!is.null(ETFObject$`data_change_date`)) {
        self$`data_change_date` <- ETFObject$`data_change_date`
      }
      if (!is.null(ETFObject$`close_date`)) {
        self$`close_date` <- ETFObject$`close_date`
      }
      if (!is.null(ETFObject$`is_live_listed`)) {
        self$`is_live_listed` <- ETFObject$`is_live_listed`
      }
      if (!is.null(ETFObject$`legal_structure`)) {
        self$`legal_structure` <- ETFObject$`legal_structure`
      }
      if (!is.null(ETFObject$`intraday_nav_ticker`)) {
        self$`intraday_nav_ticker` <- ETFObject$`intraday_nav_ticker`
      }
      if (!is.null(ETFObject$`primary_ticker`)) {
        self$`primary_ticker` <- ETFObject$`primary_ticker`
      }
      if (!is.null(ETFObject$`primary_ticker_country_code`)) {
        self$`primary_ticker_country_code` <- ETFObject$`primary_ticker_country_code`
      }
      if (!is.null(ETFObject$`primary_listing_region`)) {
        self$`primary_listing_region` <- ETFObject$`primary_listing_region`
      }
      if (!is.null(ETFObject$`net_expense_ratio`)) {
        self$`net_expense_ratio` <- ETFObject$`net_expense_ratio`
      }
      if (!is.null(ETFObject$`asset_class`)) {
        self$`asset_class` <- ETFObject$`asset_class`
      }
      if (!is.null(ETFObject$`other_asset_types`)) {
        self$`other_asset_types` <- ETFObject$`other_asset_types`
      }
      if (!is.null(ETFObject$`market_cap_range`)) {
        self$`market_cap_range` <- ETFObject$`market_cap_range`
      }
      if (!is.null(ETFObject$`holds_only_nyse_stocks`)) {
        self$`holds_only_nyse_stocks` <- ETFObject$`holds_only_nyse_stocks`
      }
      if (!is.null(ETFObject$`holds_only_nasdaq_stocks`)) {
        self$`holds_only_nasdaq_stocks` <- ETFObject$`holds_only_nasdaq_stocks`
      }
      if (!is.null(ETFObject$`growth_value_tilt`)) {
        self$`growth_value_tilt` <- ETFObject$`growth_value_tilt`
      }
      if (!is.null(ETFObject$`growth_type`)) {
        self$`growth_type` <- ETFObject$`growth_type`
      }
      if (!is.null(ETFObject$`value_type`)) {
        self$`value_type` <- ETFObject$`value_type`
      }
      if (!is.null(ETFObject$`sector`)) {
        self$`sector` <- ETFObject$`sector`
      }
      if (!is.null(ETFObject$`industry`)) {
        self$`industry` <- ETFObject$`industry`
      }
      if (!is.null(ETFObject$`sub_industry`)) {
        self$`sub_industry` <- ETFObject$`sub_industry`
      }
      if (!is.null(ETFObject$`cross_sector_theme`)) {
        self$`cross_sector_theme` <- ETFObject$`cross_sector_theme`
      }
      if (!is.null(ETFObject$`natural_resources_type`)) {
        self$`natural_resources_type` <- ETFObject$`natural_resources_type`
      }
      if (!is.null(ETFObject$`excludes_financials`)) {
        self$`excludes_financials` <- ETFObject$`excludes_financials`
      }
      if (!is.null(ETFObject$`excludes_technology`)) {
        self$`excludes_technology` <- ETFObject$`excludes_technology`
      }
      if (!is.null(ETFObject$`us_or_excludes_us`)) {
        self$`us_or_excludes_us` <- ETFObject$`us_or_excludes_us`
      }
      if (!is.null(ETFObject$`developed_emerging`)) {
        self$`developed_emerging` <- ETFObject$`developed_emerging`
      }
      if (!is.null(ETFObject$`specialized_region`)) {
        self$`specialized_region` <- ETFObject$`specialized_region`
      }
      if (!is.null(ETFObject$`continent`)) {
        self$`continent` <- ETFObject$`continent`
      }
      if (!is.null(ETFObject$`latin_america_sub_group`)) {
        self$`latin_america_sub_group` <- ETFObject$`latin_america_sub_group`
      }
      if (!is.null(ETFObject$`europe_sub_group`)) {
        self$`europe_sub_group` <- ETFObject$`europe_sub_group`
      }
      if (!is.null(ETFObject$`asia_sub_group`)) {
        self$`asia_sub_group` <- ETFObject$`asia_sub_group`
      }
      if (!is.null(ETFObject$`specific_country`)) {
        self$`specific_country` <- ETFObject$`specific_country`
      }
      if (!is.null(ETFObject$`china_listing_location`)) {
        self$`china_listing_location` <- ETFObject$`china_listing_location`
      }
      if (!is.null(ETFObject$`us_state`)) {
        self$`us_state` <- ETFObject$`us_state`
      }
      if (!is.null(ETFObject$`real_estate`)) {
        self$`real_estate` <- ETFObject$`real_estate`
      }
      if (!is.null(ETFObject$`index_weighting_scheme`)) {
        self$`index_weighting_scheme` <- ETFObject$`index_weighting_scheme`
      }
      if (!is.null(ETFObject$`market_cap_weighting_type`)) {
        self$`market_cap_weighting_type` <- ETFObject$`market_cap_weighting_type`
      }
      if (!is.null(ETFObject$`fundamental_weighting_type`)) {
        self$`fundamental_weighting_type` <- ETFObject$`fundamental_weighting_type`
      }
      if (!is.null(ETFObject$`dividend_weighting_type`)) {
        self$`dividend_weighting_type` <- ETFObject$`dividend_weighting_type`
      }
      if (!is.null(ETFObject$`bond_type`)) {
        self$`bond_type` <- ETFObject$`bond_type`
      }
      if (!is.null(ETFObject$`government_bond_types`)) {
        self$`government_bond_types` <- ETFObject$`government_bond_types`
      }
      if (!is.null(ETFObject$`municipal_bond_region`)) {
        self$`municipal_bond_region` <- ETFObject$`municipal_bond_region`
      }
      if (!is.null(ETFObject$`municipal_vrdo`)) {
        self$`municipal_vrdo` <- ETFObject$`municipal_vrdo`
      }
      if (!is.null(ETFObject$`mortgage_bond_types`)) {
        self$`mortgage_bond_types` <- ETFObject$`mortgage_bond_types`
      }
      if (!is.null(ETFObject$`bond_tax_status`)) {
        self$`bond_tax_status` <- ETFObject$`bond_tax_status`
      }
      if (!is.null(ETFObject$`credit_quality`)) {
        self$`credit_quality` <- ETFObject$`credit_quality`
      }
      if (!is.null(ETFObject$`average_maturity`)) {
        self$`average_maturity` <- ETFObject$`average_maturity`
      }
      if (!is.null(ETFObject$`specific_maturity_year`)) {
        self$`specific_maturity_year` <- ETFObject$`specific_maturity_year`
      }
      if (!is.null(ETFObject$`bond_currency_denomination`)) {
        self$`bond_currency_denomination` <- ETFObject$`bond_currency_denomination`
      }
      if (!is.null(ETFObject$`laddered`)) {
        self$`laddered` <- ETFObject$`laddered`
      }
      if (!is.null(ETFObject$`zero_coupon`)) {
        self$`zero_coupon` <- ETFObject$`zero_coupon`
      }
      if (!is.null(ETFObject$`floating_rate`)) {
        self$`floating_rate` <- ETFObject$`floating_rate`
      }
      if (!is.null(ETFObject$`build_america_bonds`)) {
        self$`build_america_bonds` <- ETFObject$`build_america_bonds`
      }
      if (!is.null(ETFObject$`commodity_types`)) {
        self$`commodity_types` <- ETFObject$`commodity_types`
      }
      if (!is.null(ETFObject$`energy_type`)) {
        self$`energy_type` <- ETFObject$`energy_type`
      }
      if (!is.null(ETFObject$`agricultural_type`)) {
        self$`agricultural_type` <- ETFObject$`agricultural_type`
      }
      if (!is.null(ETFObject$`metal_type`)) {
        self$`metal_type` <- ETFObject$`metal_type`
      }
      if (!is.null(ETFObject$`inverse_leveraged`)) {
        self$`inverse_leveraged` <- ETFObject$`inverse_leveraged`
      }
      if (!is.null(ETFObject$`target_date_multi_asset_type`)) {
        self$`target_date_multi_asset_type` <- ETFObject$`target_date_multi_asset_type`
      }
      if (!is.null(ETFObject$`currency_hedged`)) {
        self$`currency_hedged` <- ETFObject$`currency_hedged`
      }
      if (!is.null(ETFObject$`currency_pair`)) {
        self$`currency_pair` <- ETFObject$`currency_pair`
      }
      if (!is.null(ETFObject$`social_environmental_type`)) {
        self$`social_environmental_type` <- ETFObject$`social_environmental_type`
      }
      if (!is.null(ETFObject$`clean_energy_type`)) {
        self$`clean_energy_type` <- ETFObject$`clean_energy_type`
      }
      if (!is.null(ETFObject$`dividend_type`)) {
        self$`dividend_type` <- ETFObject$`dividend_type`
      }
      if (!is.null(ETFObject$`regular_dividend_payor_type`)) {
        self$`regular_dividend_payor_type` <- ETFObject$`regular_dividend_payor_type`
      }
      if (!is.null(ETFObject$`holds_ml_ps`)) {
        self$`holds_ml_ps` <- ETFObject$`holds_ml_ps`
      }
      if (!is.null(ETFObject$`holds_preferred_stock`)) {
        self$`holds_preferred_stock` <- ETFObject$`holds_preferred_stock`
      }
      if (!is.null(ETFObject$`holds_closed_end_funds`)) {
        self$`holds_closed_end_funds` <- ETFObject$`holds_closed_end_funds`
      }
      if (!is.null(ETFObject$`quant_strategies_type`)) {
        self$`quant_strategies_type` <- ETFObject$`quant_strategies_type`
      }
      if (!is.null(ETFObject$`other_quant_models`)) {
        self$`other_quant_models` <- ETFObject$`other_quant_models`
      }
      if (!is.null(ETFObject$`hedge_fund_type`)) {
        self$`hedge_fund_type` <- ETFObject$`hedge_fund_type`
      }
      if (!is.null(ETFObject$`derivatives_based`)) {
        self$`derivatives_based` <- ETFObject$`derivatives_based`
      }
      if (!is.null(ETFObject$`holds_ad_rs`)) {
        self$`holds_ad_rs` <- ETFObject$`holds_ad_rs`
      }
      if (!is.null(ETFObject$`index_linked`)) {
        self$`index_linked` <- ETFObject$`index_linked`
      }
      if (!is.null(ETFObject$`includes_short_exposure`)) {
        self$`includes_short_exposure` <- ETFObject$`includes_short_exposure`
      }
      if (!is.null(ETFObject$`index_name`)) {
        self$`index_name` <- ETFObject$`index_name`
      }
      if (!is.null(ETFObject$`parent_index`)) {
        self$`parent_index` <- ETFObject$`parent_index`
      }
      if (!is.null(ETFObject$`index_family`)) {
        self$`index_family` <- ETFObject$`index_family`
      }
      if (!is.null(ETFObject$`broader_index_family`)) {
        self$`broader_index_family` <- ETFObject$`broader_index_family`
      }
      if (!is.null(ETFObject$`index_provider`)) {
        self$`index_provider` <- ETFObject$`index_provider`
      }
      if (!is.null(ETFObject$`fund_family`)) {
        self$`fund_family` <- ETFObject$`fund_family`
      }
      if (!is.null(ETFObject$`index_ticker`)) {
        self$`index_ticker` <- ETFObject$`index_ticker`
      }
      if (!is.null(ETFObject$`etn_issuing_bank`)) {
        self$`etn_issuing_bank` <- ETFObject$`etn_issuing_bank`
      }
      if (!is.null(ETFObject$`etn_maturity_date`)) {
        self$`etn_maturity_date` <- ETFObject$`etn_maturity_date`
      }
      if (!is.null(ETFObject$`livestock`)) {
        self$`livestock` <- ETFObject$`livestock`
      }
      if (!is.null(ETFObject$`dynamic_futures_roll`)) {
        self$`dynamic_futures_roll` <- ETFObject$`dynamic_futures_roll`
      }
      if (!is.null(ETFObject$`index_provider_code`)) {
        self$`index_provider_code` <- ETFObject$`index_provider_code`
      }
      if (!is.null(ETFObject$`single_category_designation`)) {
        self$`single_category_designation` <- ETFObject$`single_category_designation`
      }
      if (!is.null(ETFObject$`registered_countries`)) {
        self$`registered_countries` <- ETFObject$`registered_countries`
      }
      if (!is.null(ETFObject$`issuing_entity_country_code`)) {
        self$`issuing_entity_country_code` <- ETFObject$`issuing_entity_country_code`
      }
      if (!is.null(ETFObject$`ucits`)) {
        self$`ucits` <- ETFObject$`ucits`
      }
      if (!is.null(ETFObject$`replication_structure`)) {
        self$`replication_structure` <- ETFObject$`replication_structure`
      }
      if (!is.null(ETFObject$`domicile`)) {
        self$`domicile` <- ETFObject$`domicile`
      }
      if (!is.null(ETFObject$`base_currency`)) {
        self$`base_currency` <- ETFObject$`base_currency`
      }
      if (!is.null(ETFObject$`listing_currency`)) {
        self$`listing_currency` <- ETFObject$`listing_currency`
      }
      if (!is.null(ETFObject$`fund_listing_date`)) {
        self$`fund_listing_date` <- ETFObject$`fund_listing_date`
      }
      if (!is.null(ETFObject$`listing_country_code`)) {
        self$`listing_country_code` <- ETFObject$`listing_country_code`
      }
      if (!is.null(ETFObject$`listing_region`)) {
        self$`listing_region` <- ETFObject$`listing_region`
      }
      if (!is.null(ETFObject$`smartvs_traditional_beta`)) {
        self$`smartvs_traditional_beta` <- ETFObject$`smartvs_traditional_beta`
      }
      if (!is.null(ETFObject$`smartvs_traditional_beta_level2`)) {
        self$`smartvs_traditional_beta_level2` <- ETFObject$`smartvs_traditional_beta_level2`
      }
      if (!is.null(ETFObject$`income_category`)) {
        self$`income_category` <- ETFObject$`income_category`
      }
      if (!is.null(ETFObject$`etp_structure_type`)) {
        self$`etp_structure_type` <- ETFObject$`etp_structure_type`
      }
      if (!is.null(ETFObject$`month_end_assets`)) {
        self$`month_end_assets` <- ETFObject$`month_end_assets`
      }
      if (!is.null(ETFObject$`etf_portfolio_turnover`)) {
        self$`etf_portfolio_turnover` <- ETFObject$`etf_portfolio_turnover`
      }
      if (!is.null(ETFObject$`firstbridge_id`)) {
        self$`firstbridge_id` <- ETFObject$`firstbridge_id`
      }
      if (!is.null(ETFObject$`firstbridge_parent_id`)) {
        self$`firstbridge_parent_id` <- ETFObject$`firstbridge_parent_id`
      }
      if (!is.null(ETFObject$`number_of_holdings`)) {
        self$`number_of_holdings` <- ETFObject$`number_of_holdings`
      }
    },
    toJSONString = function() {
      jsonlite::toJSON(self$toJSON(), auto_unbox = TRUE, pretty = TRUE)
    },
    fromJSONString = function(ETFJson) {
      ETFObject <- jsonlite::fromJSON(ETFJson, simplifyDataFrame = FALSE)
      self$setFromList(ETFObject)
    },
    setFromList = function(listObject) {
      if (!is.null(listObject$`id`)) {
        self$`id` <- listObject$`id`
      }
      else {
        self$`id` <- NA 
      }

      if (!is.null(listObject$`name`)) {
        self$`name` <- listObject$`name`
      }
      else {
        self$`name` <- NA 
      }

      if (!is.null(listObject$`ticker`)) {
        self$`ticker` <- listObject$`ticker`
      }
      else {
        self$`ticker` <- NA 
      }

      if (!is.null(listObject$`figi_ticker`)) {
        self$`figi_ticker` <- listObject$`figi_ticker`
      }
      else {
        self$`figi_ticker` <- NA 
      }

      if (!is.null(listObject$`ric`)) {
        self$`ric` <- listObject$`ric`
      }
      else {
        self$`ric` <- NA 
      }

      if (!is.null(listObject$`isin`)) {
        self$`isin` <- listObject$`isin`
      }
      else {
        self$`isin` <- NA 
      }

      if (!is.null(listObject$`sedol`)) {
        self$`sedol` <- listObject$`sedol`
      }
      else {
        self$`sedol` <- NA 
      }

      if (!is.null(listObject$`exchange_mic`)) {
        self$`exchange_mic` <- listObject$`exchange_mic`
      }
      else {
        self$`exchange_mic` <- NA 
      }

      if (!is.null(listObject$`sponsor`)) {
        self$`sponsor` <- listObject$`sponsor`
      }
      else {
        self$`sponsor` <- NA 
      }

      if (!is.null(listObject$`type`)) {
        self$`type` <- listObject$`type`
      }
      else {
        self$`type` <- NA 
      }

      if (!is.null(listObject$`description`)) {
        self$`description` <- listObject$`description`
      }
      else {
        self$`description` <- NA 
      }




      if (!is.null(listObject$`inception_date`)) {
        self$`inception_date` <- self$`inception_date` <- as.Date(listObject$`inception_date`, "%Y-%m-%d")
      }
      else {
        self$`inception_date` <- NA 
      }








      if (!is.null(listObject$`data_change_date`)) {
        self$`data_change_date` <- self$`data_change_date` <- as.Date(listObject$`data_change_date`, "%Y-%m-%d")
      }
      else {
        self$`data_change_date` <- NA 
      }








      if (!is.null(listObject$`close_date`)) {
        self$`close_date` <- self$`close_date` <- as.Date(listObject$`close_date`, "%Y-%m-%d")
      }
      else {
        self$`close_date` <- NA 
      }










      if (!is.null(listObject$`is_live_listed`)) {
        self$`is_live_listed` <- listObject$`is_live_listed`
      }
      else {
        self$`is_live_listed` <- NA
      }



      if (!is.null(listObject$`legal_structure`)) {
        self$`legal_structure` <- listObject$`legal_structure`
      }
      else {
        self$`legal_structure` <- NA 
      }

      if (!is.null(listObject$`intraday_nav_ticker`)) {
        self$`intraday_nav_ticker` <- listObject$`intraday_nav_ticker`
      }
      else {
        self$`intraday_nav_ticker` <- NA 
      }

      if (!is.null(listObject$`primary_ticker`)) {
        self$`primary_ticker` <- listObject$`primary_ticker`
      }
      else {
        self$`primary_ticker` <- NA 
      }

      if (!is.null(listObject$`primary_ticker_country_code`)) {
        self$`primary_ticker_country_code` <- listObject$`primary_ticker_country_code`
      }
      else {
        self$`primary_ticker_country_code` <- NA 
      }

      if (!is.null(listObject$`primary_listing_region`)) {
        self$`primary_listing_region` <- listObject$`primary_listing_region`
      }
      else {
        self$`primary_listing_region` <- NA 
      }

      if (!is.null(listObject$`net_expense_ratio`)) {
        self$`net_expense_ratio` <- listObject$`net_expense_ratio`
      }
      else {
        self$`net_expense_ratio` <- NA 
      }

      if (!is.null(listObject$`asset_class`)) {
        self$`asset_class` <- listObject$`asset_class`
      }
      else {
        self$`asset_class` <- NA 
      }

      if (!is.null(listObject$`other_asset_types`)) {
        self$`other_asset_types` <- listObject$`other_asset_types`
      }
      else {
        self$`other_asset_types` <- NA 
      }

      if (!is.null(listObject$`market_cap_range`)) {
        self$`market_cap_range` <- listObject$`market_cap_range`
      }
      else {
        self$`market_cap_range` <- NA 
      }






      if (!is.null(listObject$`holds_only_nyse_stocks`)) {
        self$`holds_only_nyse_stocks` <- listObject$`holds_only_nyse_stocks`
      }
      else {
        self$`holds_only_nyse_stocks` <- NA
      }








      if (!is.null(listObject$`holds_only_nasdaq_stocks`)) {
        self$`holds_only_nasdaq_stocks` <- listObject$`holds_only_nasdaq_stocks`
      }
      else {
        self$`holds_only_nasdaq_stocks` <- NA
      }



      if (!is.null(listObject$`growth_value_tilt`)) {
        self$`growth_value_tilt` <- listObject$`growth_value_tilt`
      }
      else {
        self$`growth_value_tilt` <- NA 
      }

      if (!is.null(listObject$`growth_type`)) {
        self$`growth_type` <- listObject$`growth_type`
      }
      else {
        self$`growth_type` <- NA 
      }

      if (!is.null(listObject$`value_type`)) {
        self$`value_type` <- listObject$`value_type`
      }
      else {
        self$`value_type` <- NA 
      }

      if (!is.null(listObject$`sector`)) {
        self$`sector` <- listObject$`sector`
      }
      else {
        self$`sector` <- NA 
      }

      if (!is.null(listObject$`industry`)) {
        self$`industry` <- listObject$`industry`
      }
      else {
        self$`industry` <- NA 
      }

      if (!is.null(listObject$`sub_industry`)) {
        self$`sub_industry` <- listObject$`sub_industry`
      }
      else {
        self$`sub_industry` <- NA 
      }

      if (!is.null(listObject$`cross_sector_theme`)) {
        self$`cross_sector_theme` <- listObject$`cross_sector_theme`
      }
      else {
        self$`cross_sector_theme` <- NA 
      }

      if (!is.null(listObject$`natural_resources_type`)) {
        self$`natural_resources_type` <- listObject$`natural_resources_type`
      }
      else {
        self$`natural_resources_type` <- NA 
      }






      if (!is.null(listObject$`excludes_financials`)) {
        self$`excludes_financials` <- listObject$`excludes_financials`
      }
      else {
        self$`excludes_financials` <- NA
      }








      if (!is.null(listObject$`excludes_technology`)) {
        self$`excludes_technology` <- listObject$`excludes_technology`
      }
      else {
        self$`excludes_technology` <- NA
      }



      if (!is.null(listObject$`us_or_excludes_us`)) {
        self$`us_or_excludes_us` <- listObject$`us_or_excludes_us`
      }
      else {
        self$`us_or_excludes_us` <- NA 
      }

      if (!is.null(listObject$`developed_emerging`)) {
        self$`developed_emerging` <- listObject$`developed_emerging`
      }
      else {
        self$`developed_emerging` <- NA 
      }

      if (!is.null(listObject$`specialized_region`)) {
        self$`specialized_region` <- listObject$`specialized_region`
      }
      else {
        self$`specialized_region` <- NA 
      }

      if (!is.null(listObject$`continent`)) {
        self$`continent` <- listObject$`continent`
      }
      else {
        self$`continent` <- NA 
      }

      if (!is.null(listObject$`latin_america_sub_group`)) {
        self$`latin_america_sub_group` <- listObject$`latin_america_sub_group`
      }
      else {
        self$`latin_america_sub_group` <- NA 
      }

      if (!is.null(listObject$`europe_sub_group`)) {
        self$`europe_sub_group` <- listObject$`europe_sub_group`
      }
      else {
        self$`europe_sub_group` <- NA 
      }

      if (!is.null(listObject$`asia_sub_group`)) {
        self$`asia_sub_group` <- listObject$`asia_sub_group`
      }
      else {
        self$`asia_sub_group` <- NA 
      }

      if (!is.null(listObject$`specific_country`)) {
        self$`specific_country` <- listObject$`specific_country`
      }
      else {
        self$`specific_country` <- NA 
      }

      if (!is.null(listObject$`china_listing_location`)) {
        self$`china_listing_location` <- listObject$`china_listing_location`
      }
      else {
        self$`china_listing_location` <- NA 
      }

      if (!is.null(listObject$`us_state`)) {
        self$`us_state` <- listObject$`us_state`
      }
      else {
        self$`us_state` <- NA 
      }

      if (!is.null(listObject$`real_estate`)) {
        self$`real_estate` <- listObject$`real_estate`
      }
      else {
        self$`real_estate` <- NA 
      }

      if (!is.null(listObject$`index_weighting_scheme`)) {
        self$`index_weighting_scheme` <- listObject$`index_weighting_scheme`
      }
      else {
        self$`index_weighting_scheme` <- NA 
      }

      if (!is.null(listObject$`market_cap_weighting_type`)) {
        self$`market_cap_weighting_type` <- listObject$`market_cap_weighting_type`
      }
      else {
        self$`market_cap_weighting_type` <- NA 
      }

      if (!is.null(listObject$`fundamental_weighting_type`)) {
        self$`fundamental_weighting_type` <- listObject$`fundamental_weighting_type`
      }
      else {
        self$`fundamental_weighting_type` <- NA 
      }

      if (!is.null(listObject$`dividend_weighting_type`)) {
        self$`dividend_weighting_type` <- listObject$`dividend_weighting_type`
      }
      else {
        self$`dividend_weighting_type` <- NA 
      }

      if (!is.null(listObject$`bond_type`)) {
        self$`bond_type` <- listObject$`bond_type`
      }
      else {
        self$`bond_type` <- NA 
      }

      if (!is.null(listObject$`government_bond_types`)) {
        self$`government_bond_types` <- listObject$`government_bond_types`
      }
      else {
        self$`government_bond_types` <- NA 
      }

      if (!is.null(listObject$`municipal_bond_region`)) {
        self$`municipal_bond_region` <- listObject$`municipal_bond_region`
      }
      else {
        self$`municipal_bond_region` <- NA 
      }






      if (!is.null(listObject$`municipal_vrdo`)) {
        self$`municipal_vrdo` <- listObject$`municipal_vrdo`
      }
      else {
        self$`municipal_vrdo` <- NA
      }



      if (!is.null(listObject$`mortgage_bond_types`)) {
        self$`mortgage_bond_types` <- listObject$`mortgage_bond_types`
      }
      else {
        self$`mortgage_bond_types` <- NA 
      }

      if (!is.null(listObject$`bond_tax_status`)) {
        self$`bond_tax_status` <- listObject$`bond_tax_status`
      }
      else {
        self$`bond_tax_status` <- NA 
      }

      if (!is.null(listObject$`credit_quality`)) {
        self$`credit_quality` <- listObject$`credit_quality`
      }
      else {
        self$`credit_quality` <- NA 
      }

      if (!is.null(listObject$`average_maturity`)) {
        self$`average_maturity` <- listObject$`average_maturity`
      }
      else {
        self$`average_maturity` <- NA 
      }

      if (!is.null(listObject$`specific_maturity_year`)) {
        self$`specific_maturity_year` <- listObject$`specific_maturity_year`
      }
      else {
        self$`specific_maturity_year` <- NA 
      }

      if (!is.null(listObject$`bond_currency_denomination`)) {
        self$`bond_currency_denomination` <- listObject$`bond_currency_denomination`
      }
      else {
        self$`bond_currency_denomination` <- NA 
      }






      if (!is.null(listObject$`laddered`)) {
        self$`laddered` <- listObject$`laddered`
      }
      else {
        self$`laddered` <- NA
      }








      if (!is.null(listObject$`zero_coupon`)) {
        self$`zero_coupon` <- listObject$`zero_coupon`
      }
      else {
        self$`zero_coupon` <- NA
      }








      if (!is.null(listObject$`floating_rate`)) {
        self$`floating_rate` <- listObject$`floating_rate`
      }
      else {
        self$`floating_rate` <- NA
      }








      if (!is.null(listObject$`build_america_bonds`)) {
        self$`build_america_bonds` <- listObject$`build_america_bonds`
      }
      else {
        self$`build_america_bonds` <- NA
      }



      if (!is.null(listObject$`commodity_types`)) {
        self$`commodity_types` <- listObject$`commodity_types`
      }
      else {
        self$`commodity_types` <- NA 
      }

      if (!is.null(listObject$`energy_type`)) {
        self$`energy_type` <- listObject$`energy_type`
      }
      else {
        self$`energy_type` <- NA 
      }

      if (!is.null(listObject$`agricultural_type`)) {
        self$`agricultural_type` <- listObject$`agricultural_type`
      }
      else {
        self$`agricultural_type` <- NA 
      }

      if (!is.null(listObject$`metal_type`)) {
        self$`metal_type` <- listObject$`metal_type`
      }
      else {
        self$`metal_type` <- NA 
      }

      if (!is.null(listObject$`inverse_leveraged`)) {
        self$`inverse_leveraged` <- listObject$`inverse_leveraged`
      }
      else {
        self$`inverse_leveraged` <- NA 
      }

      if (!is.null(listObject$`target_date_multi_asset_type`)) {
        self$`target_date_multi_asset_type` <- listObject$`target_date_multi_asset_type`
      }
      else {
        self$`target_date_multi_asset_type` <- NA 
      }






      if (!is.null(listObject$`currency_hedged`)) {
        self$`currency_hedged` <- listObject$`currency_hedged`
      }
      else {
        self$`currency_hedged` <- NA
      }



      if (!is.null(listObject$`currency_pair`)) {
        self$`currency_pair` <- listObject$`currency_pair`
      }
      else {
        self$`currency_pair` <- NA 
      }

      if (!is.null(listObject$`social_environmental_type`)) {
        self$`social_environmental_type` <- listObject$`social_environmental_type`
      }
      else {
        self$`social_environmental_type` <- NA 
      }

      if (!is.null(listObject$`clean_energy_type`)) {
        self$`clean_energy_type` <- listObject$`clean_energy_type`
      }
      else {
        self$`clean_energy_type` <- NA 
      }

      if (!is.null(listObject$`dividend_type`)) {
        self$`dividend_type` <- listObject$`dividend_type`
      }
      else {
        self$`dividend_type` <- NA 
      }

      if (!is.null(listObject$`regular_dividend_payor_type`)) {
        self$`regular_dividend_payor_type` <- listObject$`regular_dividend_payor_type`
      }
      else {
        self$`regular_dividend_payor_type` <- NA 
      }






      if (!is.null(listObject$`holds_ml_ps`)) {
        self$`holds_ml_ps` <- listObject$`holds_ml_ps`
      }
      else {
        self$`holds_ml_ps` <- NA
      }








      if (!is.null(listObject$`holds_preferred_stock`)) {
        self$`holds_preferred_stock` <- listObject$`holds_preferred_stock`
      }
      else {
        self$`holds_preferred_stock` <- NA
      }








      if (!is.null(listObject$`holds_closed_end_funds`)) {
        self$`holds_closed_end_funds` <- listObject$`holds_closed_end_funds`
      }
      else {
        self$`holds_closed_end_funds` <- NA
      }



      if (!is.null(listObject$`quant_strategies_type`)) {
        self$`quant_strategies_type` <- listObject$`quant_strategies_type`
      }
      else {
        self$`quant_strategies_type` <- NA 
      }

      if (!is.null(listObject$`other_quant_models`)) {
        self$`other_quant_models` <- listObject$`other_quant_models`
      }
      else {
        self$`other_quant_models` <- NA 
      }

      if (!is.null(listObject$`hedge_fund_type`)) {
        self$`hedge_fund_type` <- listObject$`hedge_fund_type`
      }
      else {
        self$`hedge_fund_type` <- NA 
      }

      if (!is.null(listObject$`derivatives_based`)) {
        self$`derivatives_based` <- listObject$`derivatives_based`
      }
      else {
        self$`derivatives_based` <- NA 
      }






      if (!is.null(listObject$`holds_ad_rs`)) {
        self$`holds_ad_rs` <- listObject$`holds_ad_rs`
      }
      else {
        self$`holds_ad_rs` <- NA
      }



      if (!is.null(listObject$`index_linked`)) {
        self$`index_linked` <- listObject$`index_linked`
      }
      else {
        self$`index_linked` <- NA 
      }






      if (!is.null(listObject$`includes_short_exposure`)) {
        self$`includes_short_exposure` <- listObject$`includes_short_exposure`
      }
      else {
        self$`includes_short_exposure` <- NA
      }



      if (!is.null(listObject$`index_name`)) {
        self$`index_name` <- listObject$`index_name`
      }
      else {
        self$`index_name` <- NA 
      }

      if (!is.null(listObject$`parent_index`)) {
        self$`parent_index` <- listObject$`parent_index`
      }
      else {
        self$`parent_index` <- NA 
      }

      if (!is.null(listObject$`index_family`)) {
        self$`index_family` <- listObject$`index_family`
      }
      else {
        self$`index_family` <- NA 
      }

      if (!is.null(listObject$`broader_index_family`)) {
        self$`broader_index_family` <- listObject$`broader_index_family`
      }
      else {
        self$`broader_index_family` <- NA 
      }

      if (!is.null(listObject$`index_provider`)) {
        self$`index_provider` <- listObject$`index_provider`
      }
      else {
        self$`index_provider` <- NA 
      }

      if (!is.null(listObject$`fund_family`)) {
        self$`fund_family` <- listObject$`fund_family`
      }
      else {
        self$`fund_family` <- NA 
      }

      if (!is.null(listObject$`index_ticker`)) {
        self$`index_ticker` <- listObject$`index_ticker`
      }
      else {
        self$`index_ticker` <- NA 
      }

      if (!is.null(listObject$`etn_issuing_bank`)) {
        self$`etn_issuing_bank` <- listObject$`etn_issuing_bank`
      }
      else {
        self$`etn_issuing_bank` <- NA 
      }




      if (!is.null(listObject$`etn_maturity_date`)) {
        self$`etn_maturity_date` <- self$`etn_maturity_date` <- as.Date(listObject$`etn_maturity_date`, "%Y-%m-%d")
      }
      else {
        self$`etn_maturity_date` <- NA 
      }





      if (!is.null(listObject$`livestock`)) {
        self$`livestock` <- listObject$`livestock`
      }
      else {
        self$`livestock` <- NA 
      }






      if (!is.null(listObject$`dynamic_futures_roll`)) {
        self$`dynamic_futures_roll` <- listObject$`dynamic_futures_roll`
      }
      else {
        self$`dynamic_futures_roll` <- NA
      }



      if (!is.null(listObject$`index_provider_code`)) {
        self$`index_provider_code` <- listObject$`index_provider_code`
      }
      else {
        self$`index_provider_code` <- NA 
      }

      if (!is.null(listObject$`single_category_designation`)) {
        self$`single_category_designation` <- listObject$`single_category_designation`
      }
      else {
        self$`single_category_designation` <- NA 
      }

      if (!is.null(listObject$`registered_countries`)) {
        self$`registered_countries` <- listObject$`registered_countries`
      }
      else {
        self$`registered_countries` <- NA 
      }

      if (!is.null(listObject$`issuing_entity_country_code`)) {
        self$`issuing_entity_country_code` <- listObject$`issuing_entity_country_code`
      }
      else {
        self$`issuing_entity_country_code` <- NA 
      }






      if (!is.null(listObject$`ucits`)) {
        self$`ucits` <- listObject$`ucits`
      }
      else {
        self$`ucits` <- NA
      }



      if (!is.null(listObject$`replication_structure`)) {
        self$`replication_structure` <- listObject$`replication_structure`
      }
      else {
        self$`replication_structure` <- NA 
      }

      if (!is.null(listObject$`domicile`)) {
        self$`domicile` <- listObject$`domicile`
      }
      else {
        self$`domicile` <- NA 
      }

      if (!is.null(listObject$`base_currency`)) {
        self$`base_currency` <- listObject$`base_currency`
      }
      else {
        self$`base_currency` <- NA 
      }

      if (!is.null(listObject$`listing_currency`)) {
        self$`listing_currency` <- listObject$`listing_currency`
      }
      else {
        self$`listing_currency` <- NA 
      }




      if (!is.null(listObject$`fund_listing_date`)) {
        self$`fund_listing_date` <- self$`fund_listing_date` <- as.Date(listObject$`fund_listing_date`, "%Y-%m-%d")
      }
      else {
        self$`fund_listing_date` <- NA 
      }





      if (!is.null(listObject$`listing_country_code`)) {
        self$`listing_country_code` <- listObject$`listing_country_code`
      }
      else {
        self$`listing_country_code` <- NA 
      }

      if (!is.null(listObject$`listing_region`)) {
        self$`listing_region` <- listObject$`listing_region`
      }
      else {
        self$`listing_region` <- NA 
      }

      if (!is.null(listObject$`smartvs_traditional_beta`)) {
        self$`smartvs_traditional_beta` <- listObject$`smartvs_traditional_beta`
      }
      else {
        self$`smartvs_traditional_beta` <- NA 
      }

      if (!is.null(listObject$`smartvs_traditional_beta_level2`)) {
        self$`smartvs_traditional_beta_level2` <- listObject$`smartvs_traditional_beta_level2`
      }
      else {
        self$`smartvs_traditional_beta_level2` <- NA 
      }

      if (!is.null(listObject$`income_category`)) {
        self$`income_category` <- listObject$`income_category`
      }
      else {
        self$`income_category` <- NA 
      }

      if (!is.null(listObject$`etp_structure_type`)) {
        self$`etp_structure_type` <- listObject$`etp_structure_type`
      }
      else {
        self$`etp_structure_type` <- NA 
      }

      if (!is.null(listObject$`month_end_assets`)) {
        self$`month_end_assets` <- listObject$`month_end_assets`
      }
      else {
        self$`month_end_assets` <- NA 
      }

      if (!is.null(listObject$`etf_portfolio_turnover`)) {
        self$`etf_portfolio_turnover` <- listObject$`etf_portfolio_turnover`
      }
      else {
        self$`etf_portfolio_turnover` <- NA 
      }

      if (!is.null(listObject$`firstbridge_id`)) {
        self$`firstbridge_id` <- listObject$`firstbridge_id`
      }
      else {
        self$`firstbridge_id` <- NA 
      }

      if (!is.null(listObject$`firstbridge_parent_id`)) {
        self$`firstbridge_parent_id` <- listObject$`firstbridge_parent_id`
      }
      else {
        self$`firstbridge_parent_id` <- NA 
      }

      if (!is.null(listObject$`number_of_holdings`)) {
        self$`number_of_holdings` <- listObject$`number_of_holdings`
      }
      else {
        self$`number_of_holdings` <- NA 
      }

    },
    getAsList = function() {
      listObject = list()
      listObject[["id"]] <- self$`id`
      listObject[["name"]] <- self$`name`
      listObject[["ticker"]] <- self$`ticker`
      listObject[["figi_ticker"]] <- self$`figi_ticker`
      listObject[["ric"]] <- self$`ric`
      listObject[["isin"]] <- self$`isin`
      listObject[["sedol"]] <- self$`sedol`
      listObject[["exchange_mic"]] <- self$`exchange_mic`
      listObject[["sponsor"]] <- self$`sponsor`
      listObject[["type"]] <- self$`type`
      listObject[["description"]] <- self$`description`

      listObject[["inception_date"]] <- self$`inception_date`



        

      listObject[["data_change_date"]] <- self$`data_change_date`



        

      listObject[["close_date"]] <- self$`close_date`



        



      listObject[["is_live_listed"]] <- self$`is_live_listed`

        
      listObject[["legal_structure"]] <- self$`legal_structure`
      listObject[["intraday_nav_ticker"]] <- self$`intraday_nav_ticker`
      listObject[["primary_ticker"]] <- self$`primary_ticker`
      listObject[["primary_ticker_country_code"]] <- self$`primary_ticker_country_code`
      listObject[["primary_listing_region"]] <- self$`primary_listing_region`
      listObject[["net_expense_ratio"]] <- self$`net_expense_ratio`
      listObject[["asset_class"]] <- self$`asset_class`
      listObject[["other_asset_types"]] <- self$`other_asset_types`
      listObject[["market_cap_range"]] <- self$`market_cap_range`



      listObject[["holds_only_nyse_stocks"]] <- self$`holds_only_nyse_stocks`

        



      listObject[["holds_only_nasdaq_stocks"]] <- self$`holds_only_nasdaq_stocks`

        
      listObject[["growth_value_tilt"]] <- self$`growth_value_tilt`
      listObject[["growth_type"]] <- self$`growth_type`
      listObject[["value_type"]] <- self$`value_type`
      listObject[["sector"]] <- self$`sector`
      listObject[["industry"]] <- self$`industry`
      listObject[["sub_industry"]] <- self$`sub_industry`
      listObject[["cross_sector_theme"]] <- self$`cross_sector_theme`
      listObject[["natural_resources_type"]] <- self$`natural_resources_type`



      listObject[["excludes_financials"]] <- self$`excludes_financials`

        



      listObject[["excludes_technology"]] <- self$`excludes_technology`

        
      listObject[["us_or_excludes_us"]] <- self$`us_or_excludes_us`
      listObject[["developed_emerging"]] <- self$`developed_emerging`
      listObject[["specialized_region"]] <- self$`specialized_region`
      listObject[["continent"]] <- self$`continent`
      listObject[["latin_america_sub_group"]] <- self$`latin_america_sub_group`
      listObject[["europe_sub_group"]] <- self$`europe_sub_group`
      listObject[["asia_sub_group"]] <- self$`asia_sub_group`
      listObject[["specific_country"]] <- self$`specific_country`
      listObject[["china_listing_location"]] <- self$`china_listing_location`
      listObject[["us_state"]] <- self$`us_state`
      listObject[["real_estate"]] <- self$`real_estate`
      listObject[["index_weighting_scheme"]] <- self$`index_weighting_scheme`
      listObject[["market_cap_weighting_type"]] <- self$`market_cap_weighting_type`
      listObject[["fundamental_weighting_type"]] <- self$`fundamental_weighting_type`
      listObject[["dividend_weighting_type"]] <- self$`dividend_weighting_type`
      listObject[["bond_type"]] <- self$`bond_type`
      listObject[["government_bond_types"]] <- self$`government_bond_types`
      listObject[["municipal_bond_region"]] <- self$`municipal_bond_region`



      listObject[["municipal_vrdo"]] <- self$`municipal_vrdo`

        
      listObject[["mortgage_bond_types"]] <- self$`mortgage_bond_types`
      listObject[["bond_tax_status"]] <- self$`bond_tax_status`
      listObject[["credit_quality"]] <- self$`credit_quality`
      listObject[["average_maturity"]] <- self$`average_maturity`
      listObject[["specific_maturity_year"]] <- self$`specific_maturity_year`
      listObject[["bond_currency_denomination"]] <- self$`bond_currency_denomination`



      listObject[["laddered"]] <- self$`laddered`

        



      listObject[["zero_coupon"]] <- self$`zero_coupon`

        



      listObject[["floating_rate"]] <- self$`floating_rate`

        



      listObject[["build_america_bonds"]] <- self$`build_america_bonds`

        
      listObject[["commodity_types"]] <- self$`commodity_types`
      listObject[["energy_type"]] <- self$`energy_type`
      listObject[["agricultural_type"]] <- self$`agricultural_type`
      listObject[["metal_type"]] <- self$`metal_type`
      listObject[["inverse_leveraged"]] <- self$`inverse_leveraged`
      listObject[["target_date_multi_asset_type"]] <- self$`target_date_multi_asset_type`



      listObject[["currency_hedged"]] <- self$`currency_hedged`

        
      listObject[["currency_pair"]] <- self$`currency_pair`
      listObject[["social_environmental_type"]] <- self$`social_environmental_type`
      listObject[["clean_energy_type"]] <- self$`clean_energy_type`
      listObject[["dividend_type"]] <- self$`dividend_type`
      listObject[["regular_dividend_payor_type"]] <- self$`regular_dividend_payor_type`



      listObject[["holds_ml_ps"]] <- self$`holds_ml_ps`

        



      listObject[["holds_preferred_stock"]] <- self$`holds_preferred_stock`

        



      listObject[["holds_closed_end_funds"]] <- self$`holds_closed_end_funds`

        
      listObject[["quant_strategies_type"]] <- self$`quant_strategies_type`
      listObject[["other_quant_models"]] <- self$`other_quant_models`
      listObject[["hedge_fund_type"]] <- self$`hedge_fund_type`
      listObject[["derivatives_based"]] <- self$`derivatives_based`



      listObject[["holds_ad_rs"]] <- self$`holds_ad_rs`

        
      listObject[["index_linked"]] <- self$`index_linked`



      listObject[["includes_short_exposure"]] <- self$`includes_short_exposure`

        
      listObject[["index_name"]] <- self$`index_name`
      listObject[["parent_index"]] <- self$`parent_index`
      listObject[["index_family"]] <- self$`index_family`
      listObject[["broader_index_family"]] <- self$`broader_index_family`
      listObject[["index_provider"]] <- self$`index_provider`
      listObject[["fund_family"]] <- self$`fund_family`
      listObject[["index_ticker"]] <- self$`index_ticker`
      listObject[["etn_issuing_bank"]] <- self$`etn_issuing_bank`

      listObject[["etn_maturity_date"]] <- self$`etn_maturity_date`



        
      listObject[["livestock"]] <- self$`livestock`



      listObject[["dynamic_futures_roll"]] <- self$`dynamic_futures_roll`

        
      listObject[["index_provider_code"]] <- self$`index_provider_code`
      listObject[["single_category_designation"]] <- self$`single_category_designation`
      listObject[["registered_countries"]] <- self$`registered_countries`
      listObject[["issuing_entity_country_code"]] <- self$`issuing_entity_country_code`



      listObject[["ucits"]] <- self$`ucits`

        
      listObject[["replication_structure"]] <- self$`replication_structure`
      listObject[["domicile"]] <- self$`domicile`
      listObject[["base_currency"]] <- self$`base_currency`
      listObject[["listing_currency"]] <- self$`listing_currency`

      listObject[["fund_listing_date"]] <- self$`fund_listing_date`



        
      listObject[["listing_country_code"]] <- self$`listing_country_code`
      listObject[["listing_region"]] <- self$`listing_region`
      listObject[["smartvs_traditional_beta"]] <- self$`smartvs_traditional_beta`
      listObject[["smartvs_traditional_beta_level2"]] <- self$`smartvs_traditional_beta_level2`
      listObject[["income_category"]] <- self$`income_category`
      listObject[["etp_structure_type"]] <- self$`etp_structure_type`
      listObject[["month_end_assets"]] <- self$`month_end_assets`
      listObject[["etf_portfolio_turnover"]] <- self$`etf_portfolio_turnover`
      listObject[["firstbridge_id"]] <- self$`firstbridge_id`
      listObject[["firstbridge_parent_id"]] <- self$`firstbridge_parent_id`
      listObject[["number_of_holdings"]] <- self$`number_of_holdings`
      return(listObject)
    }
  )
)
